;
;     CURS_BOT() - returns the actual ending scan line of the cursor
;
;     Parameters: None
;
;     Return Value: integer
;
;     Assembled with Microsoft MASM 4.0
;
;     Written by Greg Lief 03/03/89
;

  INCLUDE \CLIPPER\EXTENDA.INC
  Name                 CURSBOT
  Public               CURS_BOT
  Extrn                __ret:far
  Extrn                __retNI:far

  DGROUP GROUP         DATASG
  DATASG SEGMENT       PUBLIC '_DATA'
  DATASG               ENDS

  _PROG                SEGMENT  'CODE'
                       ASSUME     CS:_PROG,DS:DGROUP,ES:DGROUP


  CURS_BOT             PROC       FAR

;------------------- Save Current Registers ----------------------
                       PUSH       BP
                       MOV        BP,SP
                       PUSH       DS
                       PUSH       ES
                       PUSH       SI
                       PUSH       DI

;----------------------------  BIOS call --------------------------
                       MOV AH, 3            ;  Video Service 3
                       MOV BH, 0            ;  Video Page 0
                       INT 10H              ;  Video BIOS request

;-----------  move ending scan line from CL to AX -------------
                       MOV        AX,0
                       MOV        AL,CL

;------------  restore registers --------------
                       Pop        DI
                       Pop        SI
                       Pop        ES
                       Pop        DS
                       Pop        BP

;---------  return the value and quit ---------
                       Push       AX
                       CALL       __RETNI
                       ADD        SP,2
                       call       __ret
                       Ret

  CURS_BOT             Endp
  _Prog                Ends
                       End
