;
;     SWAPCURS() - my valiant attempt to make MEMOEDIT() look more
;     like a "real" word processor by changing the cursor size based
;     on the current mode (insert vs. overwrite)
;
;     Parameters: None
;
;     Return Value: integer
;
;     Gets start and end cursor scan lines from BIOS (Video Svc 3)
;     If start scan line is 0, changes it to ending scan line - 1 (skinny)
;     otherwise changes start scan line to 0 (fat)
;
;     Assembled with Microsoft MASM  4.0
;
;     Written by Greg Lief 2/21/89
;

  INCLUDE \CLIPPER\EXTENDA.INC
  Name                 CURSOR
  Public               SWAPCURS
  Extrn                __ret:far

  DGROUP GROUP         DATASG
  DATASG SEGMENT       PUBLIC '_DATA'
  DATASG               ENDS

  _PROG                SEGMENT  'CODE'
                       ASSUME     CS:_PROG,DS:DGROUP,ES:DGROUP


  SWAPCURS             PROC       FAR

;------------------- Save Current Registers ----------------------
                       PUSH       BP
                       MOV        BP,SP
                       PUSH       DS
                       PUSH       ES
                       PUSH       SI
                       PUSH       DI

;-------------------  BIOS call  ---------------------------------
                       MOV AH, 3            ;  Video Service 3
                       MOV BH, 0            ;  Video Page 0
                       INT 10H              ;  Video BIOS request

;  returns starting cursor scan line in CH, and ending scan line in CL
                       CMP        CH,0
                       JNE        Part2
                       MOV        BL, CL
                       SUB        BL, 1
                       MOV        CH,BL
                       JMP        Part3

PART2:                 MOV        CH,0

PART3:                 MOV        AH,01
                       INT        10H
                       POP        DI
                       POP        SI
                       POP        ES
                       POP        DS
                       POP        BP
                       CALL       __RET
                       RET

  SWAPCURS             ENDP
  _Prog                ENDS
                       END
