;
;     EGAVGA() - test for presence of EGA/VGA adapter
;
;     Parameters: None
;
;     Return Value: Logical -- .T. if EGA/VGA, .F. if not
;
;     Assembled with Microsoft MASM 4.0
;
;     Written by Greg Lief 08/04/90
;

  INCLUDE c:\CLIPPER\EXTENDA.INC
  Name                 $EGAVGA
  Public               EGAVGA
  Extrn                __ret:far
  Extrn                __retL:far

  DGROUP GROUP         DATASG
  DATASG SEGMENT       PUBLIC '_DATA'
  DATASG               ENDS

  _PROG                SEGMENT  'CODE'
                       ASSUME     CS:_PROG,DS:DGROUP,ES:DGROUP


  EGAVGA               PROC       FAR

;------------------- Save Current Registers ----------------------
                       PUSH       BP
                       MOV        BP,SP
                       PUSH       DS
                       PUSH       ES
                       PUSH       SI
                       PUSH       DI

;----------------------------  BIOS call --------------------------
                       MOV AX, 01200h
                       MOV BX, 0FF10h
                       INT 10H              ;  Video BIOS request

;--------  if value returned to BX is 0FEFCh, we've got a live one -------
                       TEST       BX, 0FEFCh
                       JNZ        not_present
                       MOV        AX, 1
                       JMP        short keep_going
not_present:
                       XOR        AX, AX    ;  zero out AX register

keep_going:
;------------  restore registers --------------
                       Pop        DI
                       Pop        SI
                       Pop        ES
                       Pop        DS
                       Pop        BP

;---------  return the value and quit ---------
                       Push       AX
                       CALL       __retL
                       ADD        SP,2
                       call       __ret
                       Ret

  EGAVGA               Endp
  _Prog                Ends
                       End
