#include "D:\CL52\INCLUDE\EXTEND.API"
#include "D:\CL52\INCLUDE\GT.API"

#define EM_BUTTON_1_DOWN   0x02
#define EM_BUTTON_1_UP     0x04
#define EM_BUTTON_2_DOWN   0x08
#define EM_BUTTON_2_UP     0x10
#define EM_BUTTON_3_DOWN   0x20
#define EM_BUTTON_3_UP     0x40
#define EM_KEY_PRESS       0x80

typedef struct
{
	short int row;
	short int col;
} POINT;

typedef POINT far * POINTP;

typedef struct
{
	USHORT etype;
	USHORT eflags;

	union
	{
		struct
		{
			USHORT button;
			POINT pt;
		} mdat;

		struct
		{
			USHORT key;
			USHORT vkey;
			USHORT ksflags;
		} kdat;
	} edat;
} LOWEVENT;

typedef LOWEVENT far * LOWEVENTP;

typedef struct
{
   int AX;
   int BX;
   int CX;
   int DX;
} REGINFO;

typedef REGINFO * REGINFOP;

typedef struct
{
   unsigned int map_height;
   unsigned int map_width;
   unsigned int planes;
   unsigned int bitcount;
   unsigned int color_count;
} MAPINFO;

typedef MAPINFO * MAPINFOP;

typedef union
{
   void far * Address;
   struct
   {
      unsigned int Offset;
      unsigned int Segment;
   } Pointer;
} FARPTR;

void cdecl _dynLoadModule( unsigned int *, char * );
void cdecl _dynGetNamedAddr( unsigned int, char *, void * );
void cdecl _dynFreeModule( unsigned int );
void cdecl _evLow( unsigned int, ... );
void cdecl _reta( unsigned int );

static unsigned int ( pascal * mouseEntry )( unsigned int, REGINFOP );
static long         ( pascal * keybdEntry )( unsigned int, REGINFOP );

#define mouseInit( m )        ( * mouseEntry )(  1, m )
#define mouseExit( m )        ( * mouseEntry )(  2, m )
#define mouseNotify( m )      ( * mouseEntry )(  3, m )
#define mouseHide( m )        ( * mouseEntry )(  4, m )
#define mouseShow( m )        ( * mouseEntry )(  5, m )
#define mouseSetPos( m )      ( * mouseEntry )(  6, m )
#define mouseGetPos( m )      ( * mouseEntry )(  7, m )
#define mouseSetDblClick( m ) ( * mouseEntry )( 11, m )
#define mouseButtonCount( m ) ( * mouseEntry )( 12, m )

#define keybdTranslate( m ) ( * keybdEntry )( 8, m )

static unsigned int mouseHandle;
static unsigned int nLastRow = 0;
static unsigned int nLastCol = 0;

static unsigned char isVisible = 0;

void pascal __gfmInit( void )
{
   auto REGINFO m;
   auto FARPTR keyEntry;
   auto FARPTR eveEntry;
   auto unsigned int keybdHandle;

   _dynLoadModule( &mouseHandle, "MOUSE" );

   _dynGetNamedAddr( mouseHandle, "MOUSE_ENTRY", &mouseEntry );

   _dynLoadModule( &keybdHandle, "KEYBOARD" );

   _dynGetNamedAddr( keybdHandle, "KEYBOARD_ENTRY", &keyEntry );

   keybdEntry = keyEntry.Address;

   _dynFreeModule( keybdHandle );

   eveEntry.Address = _evLow;

   m.AX = eveEntry.Pointer.Offset; m.BX = eveEntry.Pointer.Segment;
   m.CX = keyEntry.Pointer.Offset; m.DX = keyEntry.Pointer.Segment;

   mouseInit( &m );

   _evLow( 1, EM_KEY_PRESS |  EM_BUTTON_1_DOWN | EM_BUTTON_2_DOWN, 1 );

   return;
}



void pascal __gfmExit( void )
{
   auto REGINFO m;

   m.AX = 0; m.BX = 0; m.CX = 0; m.DX = 0;

   mouseExit( &m );

   _dynFreeModule( mouseHandle );

   return;
}



void pascal __gfmNotify( void )
{
   auto MAPINFO m;
   auto REGINFO r;
   auto FARPTR p;

   m.map_height   = _gtMaxRow() + 1;
   m.map_width    = _gtMaxCol() + 1;
   m.planes       = 0;
   m.bitcount     = 0;
   m.color_count  = 0;

   p.Address = &m;

   r.AX = p.Pointer.Offset;  r.BX = p.Pointer.Segment;r.CX = 0; r.DX = 0;

   mouseNotify( &r );

   return;
}



void pascal __gfmHide( void )
{
   auto REGINFO m;

   if ( isVisible )
   {
      m.AX = 0; m.BX = 0; m.CX = 0; m.DX = 0;

      mouseHide( &m );

      isVisible = 0;
   }

   return;
}



void pascal __gfmShow( void )
{
   auto REGINFO m;

   if ( ! isVisible )
   {
      m.AX = 0; m.BX = 0; m.CX = 0; m.DX = 0;

      mouseShow( &m );

      isVisible = 1;
   }

   return;
}



void pascal __gfmCurs( void )
{
   _retl( isVisible );

   if ( _parinfo( 1 ) & LOGICAL )
      if ( _parl( 1 ) )
         __gfmShow();
      else
         __gfmHide();

   return;
}



void pascal __gfmSetP( void )
{
   auto POINT p;
   auto REGINFO m;
   auto FARPTR pP;

   pP.Address = &p;

   p.row = _parni( 1 );
   p.col = _parni( 2 );

   m.AX = pP.Pointer.Offset ; m.BX = pP.Pointer.Segment ; m.CX = 0; m.DX = 0;

   mouseSetPos( &m );

   return;
}



void pascal __gfmGetP( void )
{
   auto POINT p;
   auto REGINFO m;
   auto FARPTR pP;

   pP.Address = &p;

   m.AX = pP.Pointer.Offset ; m.BX = pP.Pointer.Segment ; m.CX = 0; m.DX = 0;

   mouseGetPos( &m );

   _reta( 2 );

   _storni( p.row, -1, 1 );
   _storni( p.col, -1, 2 );

   return;
}



void pascal __gfmDblCl( void )
{
   auto REGINFO m;

   m.AX = _parni( 1 ); m.BX = 0; m.CX = 0; m.DX = 0;

   mouseSetDblClick( &m );

   return;
}



void pascal gfLastRow( void )
{
   _retni( nLastRow ); return;
}



void pascal gfLastCol( void )
{
   _retni( nLastCol ); return;
}



void pascal IsMouse( void )
{
   auto REGINFO m;

   m.AX = 0; m.BX = 0; m.CX = 0; m.DX = 0;

   _retl( ( int ) mouseButtonCount( &m ) );

   return;
}



void pascal enableDrag( void )
{
   _evLow( 1, EM_BUTTON_1_UP, _parl( 1 ) );

   return;
}



int pascal __ButtPainAlleviate( LOWEVENTP eP )
{
   auto unsigned int n;

   switch ( eP->etype )
   {
      case 1 :
      case 2 :
      case 3 : nLastRow = eP->edat.mdat.pt.row;
               nLastCol = eP->edat.mdat.pt.col;

               n = eP->edat.mdat.button - 1;

               eP->edat.kdat.key = 0xB000 + ( ( eP->etype + ( n << 4 ) ) << 8 );

               eP->etype  = 5;
               eP->eflags =
               eP->edat.kdat.vkey =
               eP->edat.kdat.ksflags = 0;
   }

   return 0;
}