/*
    Function: GKeyList()
    Purpose:  Alternate for GetApplyKey()
              for list clause
    Author:   Greg Lief
    Copyright (c) 1991-95 Greg Lief
    Dialect:  CA-Clipper 5.x

    Compile with "/dMOUSE" command-line option for mouse support!
*/

#include "inkey.ch"
#include "getexit.ch"

#ifdef MOUSE
   #include "grump.ch"  // for mouse constants
#endif

#define VALUES        get:cargo[3]
#define POINTER       get:cargo[4]

procedure gkeylist(get, key)
local cKey
local oldvalue

#ifdef MOUSE

if key == K_LEFT_DOWN .and. GFLastRow() == get:row .and. GFLastCol() == get:col
   key := 32
endif

#endif

// check for SET KEY and basic movement keys
if ! GKeyBasic(get, key)

   do case

      case (key == K_CTRL_U)
         get:Undo()

      case (key == K_BS)
         if POINTER == 1
            POINTER := len(VALUES)
         else
            POINTER--
         endif
         // must pad the buffer to maximum length so as to
         // avoid leftover flotsam from previous item
         get:changed := .t.
         get:varPut(padr(VALUES[POINTER], len(get:picture)))
         get:updateBuffer()

      case (key == 32)
         if POINTER == len(VALUES)
            POINTER := 1
         else
            POINTER++
         endif
         // must pad the buffer to maximum length so as to
         // avoid leftover flotsam from previous item
         get:changed := .t.
         get:varPut(padr(VALUES[POINTER], len(get:picture)))
         get:updateBuffer()

   endcase
endif
return
