#include "D:\CL52\INCLUDE\EXTEND.API"
#include "CPMI.H"

typedef struct
{
   char junk[ 12 ];
   void * func;
} SYMBOL;

typedef union
{
   long far * Address;
   struct
   {
      unsigned int Offset;
      unsigned int Segment;
   } Pointer;
} LONGPTR;

SYMBOL * cdecl _Get_Sym( char * );
void cdecl _PutSym( void * );
void cdecl _evLow( unsigned int, void *, unsigned int );
void cdecl _bcopy( void *, void *, unsigned int );
void cdecl _PutQ( unsigned int );
void cdecl _xDo( unsigned int );

static long Ticks = 0;
static long Interval = 1;
static char funcName[ 11 ];
static char inProgress = 0;

#define TIMER ( ( long * ) ( 0x0000046c ) )

static void cdecl WatchDog( void )
{
   auto int isProtMode = cpmiIsProtected();
   auto LONGPTR Timer;
   auto SYMBOL * pSym;

   if ( inProgress ) return;

   inProgress = 1;

   if ( isProtMode )
   {
      Timer.Pointer.Segment = cpmiProtectedPtr( TIMER, sizeof( long ) );
      Timer.Pointer.Offset  = 0;
   }
   else
      Timer.Address = TIMER;

   if ( ( *Timer.Address >= ( Ticks + Interval ) ) || ( *Timer.Address < Ticks ) )
   {
      Ticks = *Timer.Address;

      pSym = _Get_Sym( funcName );

      if ( pSym != NULL )
      {
         _PutSym( pSym );

         _PutQ( 0 );

         _xDo( 0 );
      }
   }

   if ( isProtMode ) cpmiFreeSelector( Timer.Pointer.Segment );

   inProgress = 0;

   return;
}



CLIPPER gfOnTick( void )
{
   auto unsigned int nLen = _parclen( 1 );
   auto char * pName;
   auto SYMBOL * Symbol;

   if ( nLen > 10 ) nLen = 10;

   if ( nLen == 0 )
      _evLow( 5, WatchDog, FALSE );
   else
   {
      Interval = _parnl( 2 );

      pName = _parc( 1 );

      Symbol = _Get_Sym( pName );

      _bcopy( funcName, pName, nLen );

      funcName[ nLen + 1 ] = 0;

      _evLow( 5, WatchDog, TRUE );
   }

   return;
}