**
**  GRUMPBROW()
**  Grumpfish Library
**  Author: Greg Lief
**  Copyright (c) 1990 Greg Lief
**
**  Syntax:  GRUMPBROW([<security>, <top>, <left>, <bottom>, <right>, ;
**           <box>, <fields>, <heads>, <pictures>, <alternates>])
**
**
FUNCTION grumpbrow
PARAM sec_level, mtop, mleft, mbottom, mright, mbox, fields_, heads_, ;
      pics_, alternate_
PRIVATE security[6], qrystring, num_flds, oldscrn, mscrnfile, mid, xx, ;
        mfield, mtype, paintok, prev_color
oldscrn = SAVESCREEN(0, 0, 24, 79)
mscrnfile = ALIAS() + '.GFS'
sec_level = IF(PCOUNT() = 0, "", sec_level)
mtop = IF(PCOUNT() < 2, 0, mtop)
mleft = IF(PCOUNT() < 3, 0, mleft)
mbottom = IF(PCOUNT() < 4, 23, MIN(mbottom, 23))
mright = IF(PCOUNT() < 5, 79, mright)
mbox = IF(PCOUNT() < 6, .T., IF(TYPE('mbox') != 'L', .T., mbox))
** security[1] = Add
** security[2] = Delete
** security[3] = Edit
** security[4] = Query
** security[5] = Search
** security[6] = View
qrystring = []       && used for querying the database below
options = []
AFILL(security, .F.)
IF "A" $ UPPER(sec_level)
   security[1] = .T.
   options = options + "[A]dd  "
ENDIF
IF "D" $ UPPER(sec_level)
   security[2] = .T.
   options = options + "[D]elete  "
ENDIF
IF "E" $ UPPER(sec_level)
   security[3] = .T.
   options = options + "[E]dit  "
ENDIF
IF "Q" $ UPPER(sec_level)
   security[4] = .T.
   options = options + "[Q]uery  "
ENDIF
IF "S" $ UPPER(sec_level) .AND. ! EMPTY(INDEXKEY(0))
   security[5] = .T.
   options = options + "[S]earch  "
ENDIF
IF "V" $ UPPER(sec_level)
   security[6] = .T.
   options = options + "[V]iew  "
ENDIF
options = options + "[Esc]=quit"
*** must pass a "P" in the security parameter to allow screen painting
paintok = ("P" $ UPPER(sec_level))
saycolor = 'W/B'
getcolor = 'I'
prev_color = SETCOLOR(saycolor + ',' + getcolor + ',,,' + saycolor)

*** create array fields_ if necessary
IF PCOUNT() < 7
   xx = .T.
ELSEIF TYPE('fields_') != "A"
   xx = .T.
ELSE
   xx = .F.
ENDIF
IF xx
   num_flds = FCOUNT()
   PRIVATE fields_[num_flds]
   Afields(fields_)
ELSE
   num_flds = LEN(fields_)
ENDIF

*** create array heads_ (column headings) if necessary
IF PCOUNT() < 8
   xx = .T.
ELSEIF TYPE('heads_') != "A"
   xx = .T.
ELSE
   xx = .F.
ENDIF
IF xx
   PRIVATE heads_[num_flds]
   ACOPY(fields_, heads_)
ENDIF

*** PICLENS_ will hold the length of each GET
PRIVATE piclens_[num_flds]

*** create array PICS_ (PICTURE clauses) if necessary
IF PCOUNT() < 9
   xx = .T.
ELSEIF TYPE('pics_') != "A"
   xx = .T.
ELSE
   xx = .F.
ENDIF
IF xx
   *** okay - create the array and fill it with garbage hi bit ASCII
   *** why?  because we must go through the following FOR..NEXT regardless
   *** of whether or not they passed the PICS_ array.  I didn't want to
   *** duplicate the code because that is totally wasteful, so I resorted
   *** to CHR(254) as an indicator that we had to create the array here.
   PRIVATE pics_[num_flds]
   AFILL(pics_, CHR(254))
ENDIF
*** determine PICTURE clause and length of GET for each field
*
FOR xx = 1 TO num_flds
   mfield = fields_[xx]
   mtype = TYPE(mfield)
   DO CASE

      CASE mtype = 'D'
         pics_[xx] = IF(pics_[xx] = CHR(254), "@D", pics_[xx])
         piclens_[xx] = 8

      CASE mtype = 'M'
         pics_[xx] = "<memo>"
         piclens_[xx] = 6

      CASE mtype = 'C'
         IF pics_[xx] = CHR(254)
            piclens_[xx] = LEN(&mfield)
            *** limit maximum width to 35 characters
            IF piclens_[xx] > 35
               pics_[xx] = "@S35"
               piclens_[xx] = 35
            ELSE
               pics_[xx] = REPLICATE("X", piclens_[xx])
            ENDIF
         ELSE
            piclens_[xx] = LEN(&mfield)
         ENDIF

      CASE mtype = 'L'
         IF pics_[xx] = CHR(254)
            pics_[xx] = "Y"
            piclens_[xx] = 1
         ELSE
            mid = pics_[xx]
            piclens_[xx] = LEN(&mid)
         ENDIF

      OTHERWISE
         IF pics_[xx] = CHR(254)
            mid = STR(&mfield)
            IF "." $ mid
               pics_[xx] = REPLICATE('9', AT(".", mid) - 1) + "."
               pics_[xx] = pics_[xx] + REPLICATE('9', LEN(mid) - LEN(pics_[xx]))
            ELSE
               pics_[xx] = REPLICATE('9', LEN(mid))
            ENDIF
         ENDIF
         piclens_[xx] = LEN(pics_[xx])
   ENDCASE
NEXT

*** create array ALTERNATE_ (alternate functions) if necessary
IF PCOUNT() < 10
   PRIVATE alternate_[6]
   AFILL(alternate_, [])
ENDIF
SET DELETED ON
SET SCOREBOARD OFF
IF mbox
   ShadowBox(mtop, mleft, mbottom, mright, 1)
   mid = mleft + (INT(mright - mleft) / 2)   && calculate midpoint
   @ mbottom, mid - INT(LEN(options)/2) SAY options
ELSE
   @ 24, INT((80 - LEN(options))/2) SAY options
ENDIF

*** DBEDIT() "anomaly": the first record will be displayed no matter what,
*** even if it is deleted and SET DELETED is ON - how annoying!!!!!!!!!
IF DELETED()
   SKIP
ENDIF

DBEDIT(mtop + IF(mbox, 1, 0), mleft + IF(mbox, 1, 0), mbottom - IF(mbox, 1, 0), ;
       mright - IF(mbox, 1, 0), fields_, 'gfbbrow', pics_, heads_)
SETCOLOR(prev_color)
RESTSCREEN(0, 0, 24, 79, oldscrn)
RETURN []

* end function GrumpBrow()
*--------------------------------------------------------------------*


*Ŀ
*                                      
*   GfbBrow(): UDF for the DBEDIT()    
*                                      
*
FUNCTION GfbBrow
PARAM browmode, indx
PRIVATE mode, ret_val, cur_field, cur_col, cur_row, key, keepgoing, ;
        marker
cur_field = fields_[indx]
cur_col = COL()
cur_row = ROW()
key = LASTKEY()
ret_val = 1
DO CASE
   CASE browmode < 4         && arrow keys
      **

   CASE key = 27             && Esc to exit
      ret_val = 0
      
   CASE key = 13             && Enter -- show memo or edit field
      IF TYPE(cur_field) = "M"
         SETCOLOR(getcolor)
         buffer = ShadowBox(8, 20, 16, 60, 2, cur_field)
         MEMOEDIT(&cur_field, 9, 21, 15, 59, .F.)
         ByeByeBox(buffer)
      ELSEIF security[3]   && must have Edit access to do this
         IF Rec_Lock()
            SET KEY 24 TO gfcoledit
            @ ROW(), COL() GET &cur_field PICTURE pics_[indx]
            SET CURSOR ON
            READ
            SET CURSOR OFF
            UNLOCK
            SET KEY 24 TO
         ENDIF
      ENDIF

   *** A = add
   CASE (key = 65 .OR. key = 97) .AND. security[1]
      IF ! override(1)
         gfbrecview('A')
      ENDIF
      
   *** D = delete
   CASE (key = 68 .OR. key = 100) .AND. security[2]
      IF ! override(2)
         IF Yes_no('This record will be deleted from the file',;
               'Do you want to do this')
            IF RLOCK()
               DELETE
               SKIP -1
            ELSE
               Err_msg('Unable to lock record, record not deleted')
            ENDIF
         ENDIF
      ENDIF
      ret_val = 2
      
   *** E = edit
   CASE (key = 69 .OR. key = 101) .AND. security[3]
      IF ! override(3)
         gfbrecview('E')
      ENDIF
      
   *** P = screen painter
   CASE key = 80 .OR. key = 112 .AND. paintok
      gfbrecview('S')
      
   *** Q = query
   CASE (key = 81 .OR. key = 113) .AND. security[4]
      IF ! override(4)
         keepgoing = .T.
         IF ! EMPTY(qrystring)
            IF Yes_No("Use most recent query search criteria")
               keepgoing = .F.
               marker = RECNO()
               CONTINUE
               IF EOF()
                  Err_Msg("No more matches")
                  GO marker
               ENDIF
            ENDIF
         ENDIF
         IF keepgoing
            gfbrecview('Q')
         ENDIF
      ENDIF

   *** S = search
   CASE (key = 83 .OR. key = 115) .AND. security[5]
      IF ! override(5) .AND. TYPE(INDEXKEY(0)) = "C"
         gfbsearch()
      ENDIF

   *** V = view
   CASE (key = 86 .OR. key = 118) .AND. security[6]
      IF ! override(6)
         gfbrecview('V')
      ENDIF

   CASE key = 279        && Alt-I: switch index order
      *** first make sure that there is a second index
      IF ! EMPTY(INDEXKEY(2))
         SET ORDER TO IF(INDEXORD() = 1, 2, 1)
      ENDIF
      ret_val = 2
      
ENDCASE
SETCOLOR(saycolor + ',' + getcolor)
RETURN(ret_val)

* end function GFBBrow()
*--------------------------------------------------------------------*


*Ŀ
*                                                                        
*   Override(): See if a procedure/function name was passed to override  
*               the generic add/edit/delete/search routines -- if so,    
*               and if it exists in the application, run that instead    
*               of the generic routine                                   
*                                                                        
*
FUNCTION override
PARAMETER melement
PRIVATE mproc, ret_val, xx
ret_val = .F.
IF ! EMPTY(alternate_[melement])
   mproc = alternate_[melement]
   IF ! TYPE(mproc) $ 'UE'
      ret_val = .T.
      xx = &mproc
   ENDIF
ENDIF
RETURN ret_val

* end function Override()
*--------------------------------------------------------------------*


*Ŀ
*                                                                       
*   GfColEdit(): this traps the down arrow when editing one field, and  
*                stuffs the keyboard in such a manner so that the user  
*                can continue editing the same field in the next record 
*                                                                       
*
FUNCTION gfcoledit
PARAMETER a,b,c
KEYBOARD CHR(13) + CHR(24) + CHR(13)
RETURN []

* end function GFColEdit()
*--------------------------------------------------------------------*


*Ŀ
*                                                                        
*   GfbRecView(): The heart of the order, so to speak.  This is          
*                 where all SAYs and GETs are SAID and GOTTEN            
*                                                                        
*
FUNCTION GfbRecView
PARAMETER mode
PRIVATE scatter[num_flds], oldscrn, picstring, mstring, mfield, mrow, ;
        pic_len, xx, marker, buffer, oldcolor, is_memo, num_boxes, ;
        goingdown, mtype, handle, firstfield, keepgoing, mainloop, curr_fld

num_boxes = 0

*** initialize array to hold GET field and box information for
*   maintenance mode or if we detect the presence of the
*   presaved screen file
*
IF mode = "S" .OR. FILE(mscrnfile)
   PRIVATE gets_[num_flds], boxes_[20]
ENDIF

*** general screen stuff, saving, clearing, status messages, etc
*
SETCOLOR(prev_color)
oldscrn = SAVESCREEN(0, 0, 24, 79)
CLEAR
IF mode != "S"
   @ 0, 2 SAY '[ ' + IF(mode = 'Q', "Query database", ;
            IF(mode = 'A', "Add" , IF(mode = "E", "Edit", "View")) + ;
            "ing Record") + ' ]'
ENDIF
IF mode $ "AEQ"
   @ 24, 25 SAY 'save edits'
   @ 24, 43 SAY 'exit without saving'
   SETCOLOR('I')
   @ 24,18 SAY 'Ctrl-W'
   @ 24,39 SAY 'Esc'
ENDIF
SETCOLOR(prev_color)

*** if we are using a pre-saved screen file, read it in now
*
IF FILE(mscrnfile)
   handle = FOPEN(mscrnfile)
   IF handle = -1
      Err_Msg("Could not open " + mscrnfile)
   ELSE
      buffer = SPACE(4000)
      *** first paint the static text by restoring the saved screen
      FREAD(handle, @buffer, 4000)
      RESTSCREEN(0, 0, 24, 79, buffer)
      buffer = [ ]
      *** then read next byte, which will tell us how many fields
      *** are stored in this file
      FREAD(handle, @buffer, 1)
      num_flds = BIN2I(buffer)
      FOR yy = 1 TO num_flds
         GFReadLine(@buffer, handle)
         gets_[yy] = buffer
      NEXT
      *** okay, now read next byte, which will tell us how many boxes
      *** are stored in this file  -- note that we are limited to 20
      buffer = [ ]
      FREAD(handle, @buffer, 1)
      num_boxes = MIN(BIN2I(buffer), 20)
      FOR xx = 1 TO num_boxes
         buffer = SPACE(14)
         FREAD(handle, @buffer, 14)
         boxes_[xx] = buffer
      NEXT
      SETCOLOR(prev_color)
      FCLOSE(handle)
   ENDIF
ENDIF

*** determine topmost row at which to paint SAYs and GETs
mrow = MAX(12 - INT(num_flds / 2), 1)
firstfield = 1
mainloop = .t.
curr_fld = 1
DO WHILE curr_fld <= num_flds .AND. mainloop
   IF FILE(mscrnfile)
      mfield = SUBSTR(gets_[curr_fld], 4, 10)
      pic_len = BIN2I(SUBSTR(gets_[curr_fld], 3, 1))
      picclause = SUBSTR(gets_[curr_fld], 14)
   ELSE
      mfield = fields_[curr_fld]
      pic_len = piclens_[curr_fld]
      picclause = pics_[curr_fld]
   ENDIF
   mtype = TYPE(mfield)

   *** determine initial value for each GET field
   DO CASE
      *** if you went nuts and changed the structure on me, there might
      *** be a field that is undefined.  I will protect you from the
      *** deadly DOS drop right here.....
      CASE mtype = 'U'
         Err_Msg(TRIM(mfield) + " is undefined - please delete the " + mscrnfile + " file")
         RESTSCREEN(0, 0, 24, 79, oldscrn)
         RETURN .F.

      CASE mtype = 'D'
         scatter[curr_fld] = IF(mode = "S", StrPad(mfield, 8), ;
                       IF(mode $ "AQ", CTOD(''), &mfield))
      CASE mtype = 'M'
         *** embed an ASCII 255 at the front of this -- we need this when
         *** in the GET loop down below so that we know that this is a memo!
         scatter[curr_fld] = IF(mode = "S", StrPad(mfield, 6), ;
                             CHR(255) + IF(mode $ "AMQ", [], &mfield))
      CASE mtype = 'C'
         scatter[curr_fld] = IF(mode = "S", StrPad(mfield, pic_len), ;
                             IF(mode $ "AQ", SPACE(pic_len), &mfield))
      CASE mtype = 'L'
         scatter[curr_fld] = IF(mode = "S", SUBSTR(mfield, 1, 1), ;
                             IF(mode $ "AQ", .F., &mfield))
      OTHERWISE
         scatter[curr_fld] = IF(mode = "S", StrPad(mfield, pic_len), ;
                             IF(mode $ "AQ", 0, &mfield))
   ENDCASE

   *** do generic SAYs and GETs only if we didn't use a pre-saved screen file
   *
   IF ! FILE(mscrnfile)
      @ curr_fld + mrow, 37 - LEN(heads_[curr_fld]) SAY heads_[curr_fld]
      IF mode = "S"
         gets_[curr_fld] = CHR(curr_fld+mrow) + CHR(39) + CHR(pic_len) + ;
                           StrPad(mfield, 10) + picclause
         oldcolor = SETCOLOR("I")
      ENDIF
      *** if this is a memo field, we want to simply display the
      *** word "<memo>" (defined above as PICSTRING) rather than
      *** showing the memo.  The memo will be displayed when they
      *** cursor to it.
      IF TYPE(mfield) = "M"
         @ curr_fld + mrow, 39 SAY "<memo>"
      ELSE
         keepgoing = .t.
         IF TYPE(mfield) = "C"
            ** truncate character fields that would spill off the right side
            IF LEN(scatter[curr_fld]) > 40
               keepgoing = .f.
               @ curr_fld + mrow, 39 SAY substr(scatter[curr_fld], 1, 40) ;
                                         PICTURE picclause
            ENDIF
         ENDIF
         IF keepgoing
            @ curr_fld + mrow, 39 SAY scatter[curr_fld] PICTURE picclause
         ENDIF
      ENDIF
      IF mode = "S"
         SETCOLOR(oldcolor)
      ENDIF
   ELSE
      *** gotta display the fields in inverse for Maintenance Mode
      IF mode = "S"
         oldcolor = SETCOLOR("I")
      ENDIF
      *** pull GET coordinates and info out of the GETS_ array
      *** NOTE: if this is a memo field, we want to simply display the
      *** word "<memo>" (defined above as PICSTRING) rather than the memo
      IF TYPE(mfield) = "M"
         @ BIN2I(SUBSTR(gets_[curr_fld], 1, 1)), ;
           BIN2I(SUBSTR(gets_[curr_fld], 2, 1)) SAY "<memo>"
      ELSE
         @ BIN2I(SUBSTR(gets_[curr_fld], 1, 1)), ;
           BIN2I(SUBSTR(gets_[curr_fld], 2, 1)) SAY scatter[curr_fld] ;
           PICTURE picclause
      ENDIF
      IF mode = "S"
         SETCOLOR(oldcolor)
      ENDIF
   ENDIF

   *** we have either reached the last field or the bottom of the screen
   *   whichever came first -- time to stop for the pause that refreshes
   *
   IF ROW() = mbottom - 1 .OR. curr_fld = num_flds
      *** GOINGDOWN is a flag that indicates in which direction we are
      *** moving through the GETs.  If it is True, then we are indeed
      *** moving downward.  If False, we are moving upward.  It is
      *** important only because when we Escape from editing a memo,
      *** we will not know where to go unless we have such a flag.
      *** Trust me -- I went through all kinds of gyrations on this one.
      goingdown = .T.
      DO CASE
         CASE mode = "S"
            gfbmaint()
            *** we must force an exit from the main loop or else
            *** the sucker will bomb horribly
            mainloop = .f.
         CASE mode != "V"
            SET CURSOR ON
            SET KEY 5  TO gfbackaget
            SET KEY 24 TO gfskipaget
            FOR yy = firstfield TO curr_fld
               *** now for the tricky part - figuring out if this is a memo.
               *** memos will look like character strings, but since we were
               *** thoughtful enough to embed the CHR(255), that will assist
               *** us in making the determination now
               is_memo = IF(TYPE('scatter[yy]') != "C", .F., ;
                         SUBSTR(scatter[yy], 1, 1) == CHR(255))
               IF ! is_memo
                  IF ! FILE(mscrnfile)
                     keepgoing = .t.
                     ** truncate characters that would spill off right side
                     IF TYPE('scatter[yy]') = "C"
                        IF LEN(pics_[yy]) > 40
                           keepgoing = .f.
                           @ yy + mrow, 39 GET scatter[yy] ;
                                           PICTURE "@S40 " +pics_[yy]
                        ENDIF
                     ENDIF
                     IF keepgoing
                        @ yy + mrow, 39 GET scatter[yy] PICTURE pics_[yy]
                     ENDIF
                  ELSE
                     @ BIN2I(SUBSTR(gets_[yy], 1, 1)), ;
                       BIN2I(SUBSTR(gets_[yy], 2, 1)) GET ;
                       scatter[yy] PICTURE SUBSTR(gets_[yy], 14)
                  ENDIF
                  READ
                  *** check last keypress
                  key = LASTKEY()
                  DO CASE
                     *** Enter -- proceed downward
                     CASE key = 13 .AND. goingdown
                        goingdown = .T.
                     *** page down -- end of this screen
                     CASE key = 3
                        yy = curr_fld
                     *** page up -- back to first GET
                     CASE key = 18
                        yy = firstfield - 1
                     *** Ctrl-W or Esc - save and then fall out
                     CASE key = 23 .OR. key = 27
                        mainloop = .f.       && force exit from main loop
                        yy = curr_fld        && force exit from this loop
                  ENDCASE
               ELSE
                  buffer = ShadowBox(mrow + yy, 20, mrow + yy + 4, 60, 2)
                  @ mrow + yy + 4, 25 SAY "Ctrl-W to save, or Esc to exit"
                  *** undefine left and right arrows for the memoedit
                  SET KEY 5  TO
                  SET KEY 24 TO
                  scatter[yy] = CHR(255) + MEMOEDIT(SUBSTR(scatter[yy], 2), ;
                                mrow + yy + 1, 21, mrow + yy + 3, 59, .T.)
                  *** okay, now define them again
                  SET KEY 5  TO gfbackaget
                  SET KEY 24 TO gfskipaget
                  IF LASTKEY() = 27 .AND. ! goingdown
                     gfbackaget()
                  ENDIF
                  ByeByeBox(buffer)
               ENDIF
            NEXT
            SET CURSOR OFF
            SET KEY 5  TO
            SET KEY 24 TO
         OTHERWISE
            INKEY(0)
      ENDCASE
      mrow = mrow - (mbottom - mtop) + 1
      *** if we still have another pageful of GETs to get,
      *** then by all means clear out the previous bunch
      IF mainloop .and. curr_fld != num_flds
         firstfield = curr_fld + 1
         IF mbox
            SCROLL(mtop + 1, mleft + 1, mbottom - 1, mright - 1, 0)
         ELSE
            SCROLL(0, 0, 24, 79, 0)
         ENDIF
      ENDIF
   ENDIF
   curr_fld = curr_fld + 1
ENDDO
CLEAR GETS
IF LASTKEY() != 27 .AND. mode $ "AEQ"
   IF mode = 'Q'          && query-by-example
      *** loop through all fields and build the query string
      qrystring = []
      FOR xx = 1 TO curr_fld - 1
         mfield = IF(FILE(mscrnfile), SUBSTR(gets_[xx], 4, 10), fields_[xx])
         mtype = TYPE(mfield)
         *** first get rid of the dratted CHR(255) at the front of any memos
         IF mtype = "M"
            scatter[xx] = SUBSTR(scatter[xx], 2)
         ENDIF
         IF ! EMPTY(scatter[xx])
            DO CASE
               CASE mtype = "N"
                  picstring = mfield + " == " + LTRIM(STR(scatter[xx]))
               CASE mtype = "L"
                  picstring = IF(! scatter[xx], "! ", "") + mfield
               CASE mtype = "D"
                  picstring = mfield + " == CTOD('" + DTOC(scatter[xx]) + "')"
               OTHERWISE
                  *** if user specified "..whatever.." in character field,
                  *** then they want to find the first occurrence containing
                  *** WHATEVER; consequently, we must first check for this
                  *** situation by looking for two periods
                  IF SUBSTR(scatter[xx], 1, 2) = '..'
                     picstring = 'UPPER([' + ;
                                 TRIM(STRTRAN(scatter[xx],'..','')) + ;
                                 ']) $ UPPER(' + mfield + ')'
                  ELSE
                     *** note the case-insensitive search
                     picstring = "UPPER(" + mfield + ") = [" + ;
                                  UPPER(TRIM(scatter[xx])) + "]"
                  ENDIF
            ENDCASE
            qrystring = qrystring + IF(! EMPTY(qrystring), " .AND. ", "") + ;
                        picstring
         ENDIF
      NEXT
      marker = RECNO()
      IF ! EMPTY(qrystring)
         LOCATE FOR &qrystring WHILE INKEY() = 0
         IF EOF()
            Err_Msg("No match found")
            GO marker
         ENDIF
      ENDIF
   ELSE     && Add/Edit mode: gather memory variables back into fields
      IF Yes_No(IF(mode = "A", "Add this new record", "Save your edits"))
         app_ok = IF(mode = "A", Add_Rec(), Rec_Lock())
         IF app_ok
            FOR xx = 1 TO curr_fld - 1
               mfield = IF(FILE(mscrnfile), SUBSTR(gets_[xx], 4, 10), fields_[xx])
               *** note: memos will still have a CHR(255) stuck on the front
               *** and we do not want to save that, so let's act accordingly
               IF TYPE(mfield) = "M"
                  REPLACE &mfield WITH SUBSTR(scatter[xx], 2)
               ELSE
                  REPLACE &mfield WITH scatter[xx]
               ENDIF
            NEXT
         ENDIF
      ENDIF
   ENDIF
ENDIF
UNLOCK
RESTSCREEN(0, 0, 24, 79, oldscrn)
RETURN []

* end function GFBRecView()
*--------------------------------------------------------------------*


*Ŀ
*                                                  
*   GfBackAGet(): trap up arrow in the READ to     
*                 move back up by one GET          
*                                                  
*
FUNCTION gfbackaget
PARAMETER a,b,c
yy = MAX(yy - 2, firstfield - 1)
*** we might have gotten here in one of two ways:
*** (a) up arrow, in which case there would have
***     been three parameters passed
*** (b) direct call when Escaping from a memofield
***     and moving upwards through the GET list
*** We only need to stuff the keyboard in the first situation.
IF PCOUNT() = 3
   KEYBOARD CHR(13)
ENDIF
goingdown = .F.
RETURN []

* end function GFBackAGet()
*--------------------------------------------------------------------*


*Ŀ
*                                                  
*   GfSkipAGet(): trap down arrow in the READ to   
*                 move down one GET                
*                                                  
*
FUNCTION gfskipaget
PARAMETER a,b,c
KEYBOARD CHR(13)
goingdown = .T.
RETURN []

* end function GFSkipAGet()
*--------------------------------------------------------------------*


*Ŀ
*                                                
*   GfbSearch(): search for a record using the   
*                tried-and-true letter jump      
*                logic of DBEDITSrch()           
*                                                
*
FUNCTION gfbsearch
PRIVATE buffer
buffer = SAVESCREEN(0, 0, 24, 79)
*** repaint bottom row of box to avoid clutter
@ mbottom, mleft + 1 SAY REPLICATE(CHR(205), mright - mleft - 1)
dbeditsrch(mtop + IF(mbox, 1, 0), mleft + IF(mbox, 1, 0), ;
           mbottom - IF(mbox, 1, 0), mright - IF(mbox, 1, 0), ;
           fields_, heads_, mbottom, mleft + (INT(mright - mleft) / 2))
RESTSCREEN(0, 0, 24, 79, buffer)
RETURN 1

* end function GFBSearch()
*--------------------------------------------------------------------*


*Ŀ
*                                                
*   GfbMaint(): The Long-Awaited Screen Painter  
*               (a/k/a "Maintenance Mode"        
*                                                
*
FUNCTION gfbmaint
PRIVATE key, mrow, mcol, mfile, buffer, oldinsert, xx, yy, mstart, ;
        keepgoing, tnum_flds, mtop, mleft, mbottom, mright, ;
        mbuff, mcolor, maincolor, buffer
tnum_flds = num_flds  && temporary counter in case they delete fields
mrow = 0
mcol = 0
CLEAR GETS
oldinsert = READINSERT(.F.)
SET CURSOR ON
key = 0
*** Esc to exit without saving changes to screen file (.GFS)
*** F10 to save changes to screen file
DO WHILE key != -9
   @ mrow, mcol SAY []
   key = INKEY(0)
   DO CASE

      *** Alt-H: help!
      CASE key = 291
         gfbhelpme()

      *** alphanumeric or something printable
      CASE key > 31 .AND. key < 250
         IF IsItAGet(mrow, mcol)
            Err_Msg("You cannot type over a GET")
         ELSE
            *** if Insert mode is on, push everything else on this row over
            IF READINSERT()
               *** we don't want to move any GETs, but how to do this?
               *** simple... we jump merrily through every character on
               *** this row and check for its color.  If its color is
               *** inverse (112), then we know it must be a GET and we
               *** skip it.
               mstart = 0
               FOR xx = 0 TO 79 - mcol
                  IF IsItAGet(mrow, mcol + xx)
                     RESTSCREEN(mrow, mcol + mstart + 1, mrow, mcol + xx - 1, ;
                               SAVESCREEN(mrow, mcol + mstart, mrow, mcol + xx - 2))
                     ** now loop through until we find the next non-GET
                     DO WHILE xx < 80-mcol .AND. IsItAGet(mrow, mcol+xx)
                        xx = xx + 1
                     ENDDO
                     mstart = xx
                  ENDIF
               NEXT
               *** if there were no GETs, mstart will still be zero.
               IF mstart = 0
                  RESTSCREEN(mrow, mcol + 1, mrow, 79, ;
                             SAVESCREEN(mrow, mcol, mrow, 78))
               ENDIF
            ENDIF
            @ mrow, mcol SAY CHR(key)
            IF mcol = 79 .AND. mrow < 24
               mrow = mrow + 1
               mcol = 0
            ELSE
               mcol = mcol + 1
            ENDIF
         ENDIF

      *** Enter: move a field or resize a box
      CASE key = 13
         IF IsItAGet(mrow, mcol)
            IF gfbmovefld()
               mrow = ROW()
               mcol = COL()
               *** let's re-sort the GETS_ array so that they will fall in the
               *** order that they appear on the screen (rather than how they
               *** appear in the .dbf)
               ASORT(gets_)
            ENDIF
         ELSE
            *** are we on a box outline?? only the shadow knows
            IF num_boxes > 0
               xx = IsItABox()
               IF xx > 0
                  gfbsizebox()
               ENDIF
            ENDIF
         ENDIF

      *** backspace
      CASE key = 8 .AND. (mcol > 0)
         mcol = mcol - 1
         *** wipe out this space if we are not on a GET
         IF ! IsItAGet(mrow, mcol)
            @ mrow, mcol SAY [ ]
         ENDIF
         @ mrow, mcol SAY []

      *** delete
      CASE key = 7
         *** first check if we are on a box outline
         xx = IsItABox()
         IF xx > 0
            IF Yes_No("Are you sure you want to delete this box")
               *** wipe it off the screen
               @ BIN2I(SUBSTR(boxes_[xx], 1, 1)), ;
                 BIN2I(SUBSTR(boxes_[xx], 2, 1)), ;
                 BIN2I(SUBSTR(boxes_[xx], 3, 1)), ;
                 BIN2I(SUBSTR(boxes_[xx], 4, 1)) BOX SPACE(8)
               *** then blast it from the array
               ADEL(boxes_, xx)
               num_boxes = num_boxes - 1
            ENDIF
         *** next check if we are on a GET field
         ELSEIF IsItAGet(mrow, mcol)
            IF Yes_No("Are you sure you want to delete this field")
               *** first find this element
               xx = gfbwhichget()
               IF xx > 0
                  *** wipe it off the screen
                  SCROLL(BIN2I(SUBSTR(gets_[xx], 1, 1)), ;
                         BIN2I(SUBSTR(gets_[xx], 2, 1)), ;
                         BIN2I(SUBSTR(gets_[xx], 1, 1)), ;
                         BIN2I(SUBSTR(gets_[xx], 2, 1)) + ;
                         BIN2I(SUBSTR(gets_[xx], 3, 1)) - 1, 0)
                  *** blast it out of the array
                  ADEL(gets_, xx)
                  tnum_flds = tnum_flds - 1
               ENDIF
            ENDIF
         ELSE
            *** note that we don't want to move any GETs, so we must check
            *** each character on this row to see if it is part of a GET.
            *** However, so that we do not have to go through this loop
            *** on lines without GETs, we do a quick scan of the array
            *** to see if there is a GET on this row
            xx = ASCAN(gets_, CHR(mrow))
            IF xx > 0      && yes there is at least one GET on this row
               mstart = 0
               FOR xx = 0 TO 79 - mcol
                  IF IsItAGet(mrow, mcol + xx)
                     RESTSCREEN(mrow, mcol + mstart, mrow, mcol + xx - 2, ;
                               SAVESCREEN(mrow, mcol + mstart + 1, mrow, mcol + xx - 1))
                     @ mrow, mcol + xx - 1 SAY [ ]
                     ** now loop through until we find the next non-GET
                     DO WHILE xx < 80-mcol .AND. IsItAGet(mrow, mcol+xx)
                        xx = xx + 1
                     ENDDO
                     mstart = xx
                  ENDIF
               NEXT
            ELSE       && no GETs on this row
               RESTSCREEN(mrow, mcol, mrow, 78, SAVESCREEN(mrow, mcol + 1, mrow, 79))
               @ mrow, 79 SAY [ ]
            ENDIF
         ENDIF

      *** toggle insert mode
      CASE key = 22
         READINSERT(! READINSERT())
         @ 0, 74 SAY IF(READINSERT(), '<Ins>', SPACE(5))

      *** Alt-P: color palette to change active color
      CASE key = 281
         SETCOLOR(ColorPal())

      *** Alt-B: draw box
      CASE key = 304
         gfbdrawbox()

      *** Shift-F10: generate code
      CASE key = -19
         mfile = UPPER(ALIAS()) + ".PRG"
         keepgoing = IF(! FILE(mfile), .T., ;
                     Yes_No(mfile + " already exists", "Overwrite it"))
         IF keepgoing
            buffer = savescreen(0, 0, 24, 79)
            gfbcleanup()
            SET PRINTER TO (mfile)
            SET PRINT ON
            *** first, let's get rid of the boxes so that they don't get displayed
            *** as part of the text
            FOR xx = 1 TO num_boxes
               @ BIN2I(SUBSTR(boxes_[xx], 1, 1)), BIN2I(SUBSTR(boxes_[xx], 2, 1)), ;
                 BIN2I(SUBSTR(boxes_[xx], 3, 1)), BIN2I(SUBSTR(boxes_[xx], 4, 1))  ;
                 BOX SPACE(8)
            NEXT
            SET CONSOLE OFF
            *** standard header -- change it as you see fit
            ? "***  Program: " + mfile
            ? "***  Date:    " + DTOC(DATE())
            ? "***  Dialect: Summer '87"
            ? "***  Generated by GrumpBrow() -- Copyright (c) 1990 Greg Lief"
            ? "***  Notes: data entry screen for " + ALIAS() + ".DBF"
            ? "***         Expects to be passed a parameter (MODE),"
            ? "***         which could be either [A]dd, [E]dit, [V]iew"
            ? "***"
            ? "PARAMETER mode"
            ? "PRIVATE "
            yy = 8
            FOR xx = 1 TO MIN(tnum_flds, 21)
               mfield = TRIM(SUBSTR(gets_[xx], 4, 10))
               yy = yy + LEN(mfield) + 3
               IF yy > 79
                  ? "PRIVATE "
                  yy = 8
               ELSEIF xx != 1
                  ?? ", "
               ENDIF
               ?? "m" + mfield
            NEXT
            ? "USE " + ALIAS()
            ?
            ? "*** static text"
            *** draw the boxes, dude
            FOR xx = 1 to num_boxes
               ? "SETCOLOR('" + Color_N2S(SUBSTR(boxes_[xx], 13, 1)) + "')"
               ? "@ " + LTRIM(STR(BIN2I(SUBSTR(boxes_[xx], 1, 1)))) + ", " + ;
                        LTRIM(STR(BIN2I(SUBSTR(boxes_[xx], 2, 1)))) + ", " + ;
                        LTRIM(STR(BIN2I(SUBSTR(boxes_[xx], 3, 1)))) + ", " + ;
                        LTRIM(STR(BIN2I(SUBSTR(boxes_[xx], 4, 1)))) + " BOX '" + ;
                        SUBSTR(boxes_[xx], 5, 8) + ;
                        IF(SUBSTR(boxes_[xx], 14, 1)= "Y", " ", "") + "'"
            NEXT
            *** now draw all other text
            maincolor = prev_color
            ? "SETCOLOR('" + maincolor + "')"
            FOR xx = 0 TO 24
               mstring = [ ]
               yy = 0
               DO WHILE yy < 80 .AND. ASC(LEFT(SAVESCREEN(xx, yy, xx, yy), 1)) < 33
                  yy = yy + 1
               ENDDO
               IF yy < 80
                  DO WHILE yy < 80
                     mstring = LEFT(SAVESCREEN(xx, yy, xx, yy), 1)
                     mcolor = SUBSTR(SAVESCREEN(xx, yy, xx, yy), 2)
                     zz = yy + 1
                     DO WHILE SUBSTR(SAVESCREEN(xx, zz, xx, zz), 2) = mcolor .AND. zz < 80
                        mstring = mstring + LEFT(SAVESCREEN(xx, zz, xx, zz), 1)
                        zz = zz + 1
                     ENDDO
                     IF ! EMPTY(mstring)
                        IF Color_S2N(maincolor) != BIN2I(mcolor)
                           maincolor = Color_N2S(mcolor)
                           ? "SETCOLOR('" + maincolor + "')"
                        ENDIF
                        ? "@ " + LTRIM(STR(xx)) + ", " + LTRIM(STR(yy)) + ;
                                  " SAY [" + TRIM(mstring) + "]"
                     ENDIF
                     yy = zz
                  ENDDO
               ENDIF
            NEXT

            ?
            ? "*** initialize memory variables"
            FOR xx = 1 TO MIN(tnum_flds, 21)
               mfield = TRIM(SUBSTR(gets_[xx], 4, 10))
               mtype = TYPE(mfield)
               IF mtype != "M"
                  ? "m" + mfield + " = IF(mode = 'A',"
                  DO CASE
                     CASE TYPE(mfield) = "D"
                        ?? "CTOD('')"
                     CASE TYPE(mfield) = "C"
                        ?? "SPACE(" + LTRIM(STR(LEN(&mfield))) + ")"
                     CASE TYPE(mfield) = "L"
                        ?? ".F."
                     CASE TYPE(mfield) = "N"
                        ?? "0.00"
                     OTHERWISE
                        ?? "[]"
                  ENDCASE
                  ?? ", " + mfield + ")"
               ENDIF
            NEXT

            *** do the GETs
            ?
            ? "*** time for the GETs"
            FOR xx = 1 TO MIN(tnum_flds, 21)
               IF TYPE(SUBSTR(gets_[xx], 4, 10)) != "M"
                  ? "@ " + LTRIM(STR(BIN2I(SUBSTR(gets_[xx], 1, 1)))) + ", " + ;
                        LTRIM(STR(BIN2I(SUBSTR(gets_[xx], 2, 1)))) + " GET m" + ;
                        TRIM(SUBSTR(gets_[xx], 4, 10)) + " PICTURE [" + ;
                        TRIM(SUBSTR(gets_[xx], 14)) + "]"
               ENDIF
            NEXT

            *** basic stuff
            ? "IF mode != 'V'"
            ? "   SET CURSOR ON"
            ? "   READ"
            ? "   SET CURSOR OFF"
            ? "ELSE"
            ? "   CLEAR GETS"
            ? "   INKEY(0)"
            ? "ENDIF"

            *** do the REPLACEs
            ?
            ? "*** do the REPLACEs if they didn't Escape out"
            ? "IF LASTKEY() != 27 .AND. mode != 'V'"
            ? "   IF mode = 'A'"
            ? "      APPEND BLANK"
            ? "   ENDIF"
            FOR xx = 1 TO tnum_flds
               mfield = TRIM(SUBSTR(gets_[xx], 4, 10))
               IF TYPE(mfield) != "M"
                  ? "   REPLACE " + mfield + " WITH m" + mfield
               ENDIF
            NEXT
            ? "ENDIF"
            ?
            ? "*** that's all, folks!"

            SET PRINT OFF
            SET PRINTER TO
            SET CONSOLE ON

            restscreen(0, 0, 24, 79, buffer)
            waiton("Code successfully generated to " + mfile)
            inkey(1)
            waitoff()
         ENDIF

      CASE key = 27
         IF Yes_No('Your changes will be lost','Are you sure you want to exit')
            EXIT
         ENDIF

      OTHERWISE
         gfarrowkey(key, 79, @mrow, @mcol)

   ENDCASE
ENDDO
READINSERT(oldinsert)

IF key != 27
   gfbcleanup()
   mfile = ALIAS() + ".GFS"
   handle = FCREATE(mfile)
   IF handle = -1
      Err_Msg("Could not create " + mfile)
   ELSE
      IF FWRITE(handle, SAVESCREEN(0, 0, 24, 79), 4000) != 4000
         Err_Msg("Error writing to " + mfile)
      ENDIF
      *** save number of fields -- restrict it to one screen full
      tnum_flds = MIN(tnum_flds, 21)
      FWRITE(handle, CHR(tnum_flds))
      FOR xx = 1 TO tnum_flds
         FWRITE(handle, gets_[xx] + CHR(13) + CHR(10))
      NEXT
      *** save number of boxes
      FWRITE(handle, CHR(num_boxes))
      IF num_boxes > 0
         FOR xx = 1 TO num_boxes
            FWRITE(handle, boxes_[xx])
         NEXT
      ENDIF
      FCLOSE(handle)
   ENDIF
ENDIF
SET CURSOR OFF
RETURN []

* end function GFBMaint()
*--------------------------------------------------------------------*


*Ŀ
*                                                      
*   GfbCleanup(): clear <INS> message and GET fields   
*                 in preparation for saving .GFS file  
*                 or generating code                   
*                                                      
*
function gfbcleanup
private mstring, xx
*** we must ensure that the <INS> message is not on the screen,
*** because if it is, it will be reflected in either the generated
*** code or the saved screen file and just cause excess confusion
mstring = []
FOR xx = 74 TO 78
   mstring = mstring + SUBSTR(SAVESCREEN(0, xx, 0, xx), 1, 1)
NEXT
IF mstring = "<Ins>"
   SCROLL(0, 74, 0, 78, 0)
ENDIF

*** next, we must go through the GETS_ array and wipe all inverse
*** GETs off the screen -- if we leave them here, they will be
*** restored when adding/editing only to be wiped out again,
*** which creates an annoying little visual blip.
SETCOLOR(saycolor)
FOR xx = 1 TO tnum_flds
   *** if we have more than one screen of GETs, we must add error-
   *** trapping here so that the thing don't crash!!
   IF TYPE('gets_[xx]') = "U"
      EXIT
   ELSE
      SCROLL(BIN2I(SUBSTR(gets_[xx], 1, 1)), ;
             BIN2I(SUBSTR(gets_[xx], 2, 1)), ;
             BIN2I(SUBSTR(gets_[xx], 1, 1)), ;
             BIN2I(SUBSTR(gets_[xx], 2, 1)) + ;
             BIN2I(SUBSTR(gets_[xx], 3, 1)) - 1, 0)
   ENDIF
NEXT
return 0

* end function GFBCleanup()
*--------------------------------------------------------------------*


*Ŀ
*                                                      
*   GfbHelpMe(): help screen for screen painting module
*                                                      
*
FUNCTION gfbhelpme
PARAM a, b, c
PRIVATE oldscrn, oldcolor
SET CURSOR OFF
oldscrn = SAVESCREEN(0, 0, 24, 79)
oldcolor = SETCOLOR("+GR/B")
@ 0,0,24,79 BOX boxtype(5)
@ 1, 19 SAY "GRUMPBROWSE() SCREEN PAINTER - ACTIVE KEYS"
SETCOLOR("+W/B")
@ 2, 16 SAY "draw box"
@ 3, 16 SAY "change color"
@ 4, 16 SAY "toggle Insert mode on/off"
@ 5, 16 SAY "destructive backspace"
@ 6, 16 SAY "delete from cursor position"
@ 7, 16 SAY "exit without saving changes"
@ 8, 16 SAY "save screen file (.GFS) and exit"
@ 9, 16 SAY "generate code for this screen and exit"
@11, 16 SAY "move left one column"
@11, 54 SAY "move right one column"
@12, 16 SAY "move to top left"
@12, 54 SAY "move to bottom right"
@13, 16 SAY "move right five columns"
@13, 54 SAY "move left five columns"
@14, 16 SAY "move to top row"
@14, 54 SAY "move to bottom row"
@15, 16 SAY "move to left column"
@15, 54 SAY "move to right column"
@17, 4 SAY "Boxes may be filled or unfilled.  If you create a filled box, any text"
@18, 4 SAY "underneath it will be pulled in, and will be displayed in the color of"
@19, 4 SAY "the box.  To delete a box, place the cursor on it outline and press"
@20, 4 SAY "Delete. To resize a box, place the cursor on it and press Enter.  To"
@21, 4 SAY "delete a GET, place the cursor on it and press Delete.  To move a GET,"
@22, 4 SAY "place the cursor on it and press Enter."
@23, 20 SAY "Press any key to return to screen painter"
SETCOLOR("I")
@ 2, 4 SAY "Alt-B"
@ 3, 4 SAY "Alt-P"
@ 4, 4 SAY "Insert"
@ 5, 4 SAY "Backspace"
@ 6, 4 SAY "Delete"
@ 7, 4 SAY "Esc"
@ 8, 4 SAY "F10"
@ 9, 4 SAY "Shift-F10"
@11, 4 SAY "LtArrow"
@11, 42 SAY "RtArrow"
@12, 4 SAY "Home"
@12, 42 SAY "End"
@13, 4 SAY "Tab"
@13, 42 SAY "Shift-Tab"
@14, 4 SAY "PgUp"
@14, 42 SAY "PgDn"
@15, 4 SAY "Ctrl-Left"
@15, 42 SAY "Ctrl-Right"
SETCOLOR(oldcolor)
INKEY(0)
SET CURSOR ON
RESTSCREEN(0, 0, 24, 79, oldscrn)
RETURN []

* end function GFBHelpMe()
*--------------------------------------------------------------------*


*Ŀ
*                                                            
*   GfbMoveFld(): logic to drag a field around on the screen 
*                                                            
*
FUNCTION gfbmovefld
PRIVATE oldcolor, xx, mrow, mcol, mlength, key, yy, buffer,  ;
        buffer2, ret_val
ret_val = .F.
mrow = ROW()
mcol = COL()
oldcolor = SETCOLOR()
xx = gfbwhichget()
IF xx > 0
   mrow  = BIN2I(SUBSTR(gets_[xx], 1, 1))
   mcol  = BIN2I(SUBSTR(gets_[xx], 2, 1))
   mlength = BIN2I(SUBSTR(gets_[xx], 3, 1))
   key = 0
   *** initialize a scrap buffer which will hold the underlying
   *** screen area as we drag the field around.  If we did not
   *** do this, then the field would act as a giant erase,
   *** annihilating static text (and other fields) in its wake!
   buffer = []
   FOR yy = 2 TO mcol + mlength
      buffer = buffer + CHR(32) + CHR(23)
   NEXT
   buffer2 = SAVESCREEN(mrow, mcol, mrow, mcol + mlength - 1)
   DO WHILE key != 13 .AND. key != 27
      @ mrow, mcol SAY []
      key = INKEY(0)
      IF key != 13 .AND. key != 27
         SETCOLOR(oldcolor)
         RESTSCREEN(mrow, mcol, mrow, mcol + mlength - 1, buffer)
         gfarrowkey(key, 80 - mlength, @mrow, @mcol)
         buffer = SAVESCREEN(mrow, mcol, mrow, mcol + mlength - 1)
         RESTSCREEN(mrow, mcol, mrow, mcol + mlength - 1, buffer2)
         buffer2 = SAVESCREEN(mrow, mcol, mrow, mcol + mlength - 1)
      ENDIF
   ENDDO
   RESTSCREEN(mrow, mcol, mrow, mcol + mlength - 1, buffer)
   IF key = 13
      ret_val = .T.
      *** make sure that we are not plopping this GET down over
      *** another one!
      FOR yy = mcol TO mcol + mlength - 1
         IF IsItAGet(mrow, yy)
            Err_Msg("You cannot place a GET on top of a GET")
            ret_val = .F.
            EXIT
         ENDIF
      NEXT
   ENDIF
   IF ret_val
      *** change this array element to reflect the new position
      gets_[xx] = CHR(mrow) + CHR(mcol) + SUBSTR(gets_[xx], 3)
      RESTSCREEN(mrow, mcol, mrow, mcol + mlength - 1, buffer2)
   ELSE
      *** either they Escaped, or they tried to place this GET
      *** on top of another one -- in either case we must now
      *** redraw the original GET
      SETCOLOR("I")
      @ BIN2I(SUBSTR(gets_[xx], 1, 1)), BIN2I(SUBSTR(gets_[xx], 2, 1)) ;
        SAY StrPad(SUBSTR(gets_[xx], 4, 10), BIN2I(SUBSTR(gets_[xx], 3, 1)))
   ENDIF
ENDIF
SETCOLOR(oldcolor)
RETURN ret_val

* end function GFBMoveFld()
*--------------------------------------------------------------------*


*Ŀ
*                                                                       
*   IsItAGet(): well, is it??  GETs will be shown on screen in inverse, 
*               so all we need to do is save a chunk of the screen and  
*               look at the color attribute if the color attribute is   
*               112 (inverse), then we must be in a GET                 
*                                                                       
*
FUNCTION IsItAGet
PARAM xx, yy
RETURN SUBSTR(SAVESCREEN(xx, yy, xx, yy), 2, 1) = CHR(112)

* end function IsItAGet()
*--------------------------------------------------------------------*


*Ŀ
*                                                                 
*   IsItABox(): determine whether or not we are on a box outline  
*               useful for resizing and deleting boxes            
*                                                                 
*
FUNCTION IsItABox
PRIVATE ret_val, xx
ret_val = 0
FOR xx = 1 TO num_boxes
   mtop = BIN2I(SUBSTR(boxes_[xx], 1, 1))
   mleft = BIN2I(SUBSTR(boxes_[xx], 2, 1))
   mbottom = BIN2I(SUBSTR(boxes_[xx], 3, 1))
   mright = BIN2I(SUBSTR(boxes_[xx], 4, 1))
   IF ((mtop = ROW() .OR. mbottom = ROW()) .AND.      ;
           mleft <= COL() .AND. mright >= COL()) .OR. ;
           ((mleft = COL() .OR. mright = COL()) .AND. ;
           mtop <= ROW() .AND. mbottom >= ROW())
      ret_val = xx
      EXIT
   ENDIF
NEXT
RETURN ret_val

* end function IsItABox()
*--------------------------------------------------------------------*


*Ŀ
*                                                  
*   GfbWhichGet(): locate current GET in get array 
*                                                  
*
FUNCTION gfbwhichget
PRIVATE mget, xx
*** figure out which field it is by scanning the array
*** for the value of the row we are currently on
mget = 0
xx = ASCAN(gets_, CHR(mrow))
DO WHILE xx > 0 .AND. mget = 0
   *** now check the length of this field (character 3 in
   *** the array element) to see if we are actually on it
   IF xx > 0
      IF mcol < BIN2I(SUBSTR(gets_[xx], 2, 1)) + BIN2I(SUBSTR(gets_[xx], 3, 1))
         mget = xx
      ELSE
         xx = ASCAN(gets_, CHR(mrow), xx + 1)
      ENDIF
   ENDIF
ENDDO
RETURN mget


*Ŀ
*                                                            
*   GfbDrawBox(): logic to drag a field around on the screen 
*                                                            
*
FUNCTION gfbdrawbox
PRIVATE boxtypes[5], buffer, mbox, key, mtop, mleft, oldscrn, mfill, ;
        mwidth, fillbuff
*** even though it seems wasteful, we must make a safety copy of
*** the entire screen because you might decide not to keep the
*** box, right?  Remember the old maxim: users change their mind
*** as often as Cher changes costumes.
oldscrn = SAVESCREEN(0, 0, 24, 79)
FOR xx = 1 TO 5
   boxtypes[xx] = SUBSTR(boxtype(xx), 1, 8)
NEXT
@ mrow, mcol SAY []
buffer = ShadowBox(9, 35, 15, 44, 2, "Boxes")
mbox = ACHOICE(10, 36, 14, 43, boxtypes)
ByeByeBox(buffer)
IF mbox > 0
   mfill = YES_NO("Would you like this box to be filled")
   IF mbox > 0
      key = 0
      mtop = mrow
      mleft = mcol
      buffer = SAVESCREEN(mtop, mleft, mrow, mcol)
      DO WHILE key != 13 .AND. key != 27
         @ mrow, mcol SAY []
         key = INKEY(0)
         IF ! ((mrow = 24 .AND. key = 24) .OR. (mrow = mtop .AND. key = 5) .OR. ;
               (mcol = mleft .AND. key = 19) .OR. (mcol > 78 .AND. key = 4))
            RESTSCREEN(mtop, mleft, mrow, mcol, buffer)
            gfarrowkey(key, 79, @mrow, @mcol)
            buffer = SAVESCREEN(mtop, mleft, mrow, mcol)
            @ mtop, mleft, mrow, mcol BOX boxtypes[mbox] + IF(mfill, " ", "")
         ENDIF
      ENDDO
      IF key = 27
         RESTSCREEN(0, 0, 24, 79, oldscrn)
         *** restore original cursor position too
         @ mtop, mleft SAY []
      ELSE
         IF mfill
            gfbfillbox(mtop, mleft, mrow, mcol)
         ENDIF
         num_boxes = num_boxes + 1
         boxes_[num_boxes] = CHR(mtop) + CHR(mleft) + CHR(mrow) + CHR(mcol) + ;
                         boxtypes[mbox] + CHR(Color_S2N()) + IF(mfill, "Y", "N")
      ENDIF
   ENDIF
ENDIF
RETURN []

* end function GFBDrawBox()
*--------------------------------------------------------------------*


*Ŀ
*                                       
*   GfbSizeBox(): logic to resize a box 
*                                       
*
FUNCTION gfbsizebox
PRIVATE oldscrn, key, buffer, oldcolor
*** once again, we must make a safety copy of the entire screen
*** because you might decide to leave the box size as is.  Picky users!
oldscrn = SAVESCREEN(0, 0, 24, 79)
key = 0
*** get rid of the box for a split second and save the underlying screen
*** otherwise, we are going to have a real mess on our hands!
@ mtop, mleft, mbottom, mright BOX SPACE(8)
buffer = SAVESCREEN(mtop, mleft, mbottom, mright)
oldcolor = SETCOLOR(Color_N2S(SUBSTR(boxes_[xx], 13, 1)))
@ mtop, mleft, mbottom, mright BOX SUBSTR(boxes_[xx], 5, 8) + ;
                       IF(SUBSTR(boxes_[xx], 14, 1) = "Y", " ", "")
DO WHILE key != 13 .AND. key != 27
   @ mbottom, mright SAY []
   key = INKEY(0)
   IF ! ((mbottom = 24 .AND. key = 24) .OR. (mbottom = mtop .AND. key = 5) .OR. ;
         (mright = mleft .AND. key = 19) .OR. (mright > 78 .AND. key = 4))
      RESTSCREEN(mtop, mleft, mbottom, mright, buffer)
      gfarrowkey(key, 79, @mbottom, @mright)
      buffer = SAVESCREEN(mtop, mleft, mbottom, mright)
      @ mtop, mleft, mbottom, mright BOX SUBSTR(boxes_[xx], 5, 8) + ;
          IF(SUBSTR(boxes_[xx], 14, 1) = "Y", " ", "")
   ENDIF
ENDDO
IF key = 27
   RESTSCREEN(0, 0, 24, 79, oldscrn)
   *** restore original cursor position too
   @ mrow, mcol SAY []
ELSE
   IF SUBSTR(boxes_[xx], 14, 1) = "Y"
      gfbfillbox(mtop, mleft, mbottom, mright)
   ENDIF
   boxes_[xx] = CHR(mtop) + CHR(mleft) + CHR(mbottom) + CHR(mright) + ;
                SUBSTR(boxes_[xx], 5)
ENDIF
SETCOLOR(oldcolor)
RETURN []

* end function GFBSizeBox()
*--------------------------------------------------------------------*


*Ŀ
*                                                 
*   GfbFillBox(): fill box with underlying screen 
*                                                 
*
FUNCTION GFBFillBox
PARAMETER mtop, mleft, mbottom, mright
*** we have just drawn a filled box.  There is every likelihood
*** that we have some relevant information underneath this box.
*** therefore, we must pull the information from the underlying
*** screen into the box.  But not so fast!  We must make this
*** information conform to the color specification of the box.
*** One more thing, leave the GETs in inverse.  Got all that?  Good.
PRIVATE mwidth, fillbuff, xx, yy, mcolor
mwidth = (mright - mleft + 1) * 2
buffer = SUBSTR(buffer, mwidth + 1, LEN(buffer) - mwidth * 2)
fillbuff = []
mcolor = CHR(Color_S2N())
FOR xx = 0 TO (mbottom - mtop - 2)
   FOR yy = 2 TO mright - mleft
      fillbuff = fillbuff + SUBSTR(buffer, xx * mwidth + yy * 2 - 1, 1)
      IF SUBSTR(buffer, xx * mwidth + yy * 2, 1) != CHR(112)
         fillbuff = fillbuff + mcolor
      ELSE
         fillbuff = fillbuff + CHR(112)
      ENDIF
   NEXT
NEXT
RESTSCREEN(mtop + 1, mleft + 1, mbottom - 1, mright - 1, fillbuff)
RETURN []

* end function GFBFillBox()
*--------------------------------------------------------------------*


*Ŀ
*                                                            
*   GfbArrowKey(): process arrow keypresses etcetera         
*                                                            
*
FUNCTION gfarrowkey
PARAMETER key, maxlength, mrow, mcol
DO CASE
   *** up arrow
   CASE key = 5
      mrow = IF(mrow = 0, 24, mrow - 1)

   *** down arrow
   CASE key = 24
      mrow = IF(mrow = 24, 0, mrow + 1)

   *** left arrow
   CASE key = 19 .AND. mcol > 0
      mcol = mcol - 1

   *** right arrow
   CASE key = 4 .AND. mcol < maxlength
      mcol = mcol + 1

   *** Home
   CASE key = 1
      mrow = 0
      mcol = 0

   *** End
   CASE key = 6
      mrow = 24
      mcol = maxlength

   *** PgUp
   CASE key = 18
      mrow = 0

   *** PgDn
   CASE key = 3
      mrow = 24

   *** Ctrl-Left
   CASE key = 26
      mcol = 0

   *** Ctrl-Right
   CASE key = 2
      mcol = maxlength

   *** Tab
   CASE key = 9
      mcol = MIN(mcol + 5, maxlength)

   *** Shift-Tab
   CASE key = 271
      mcol = MAX(mcol - 5, 0)

ENDCASE
RETURN []

* end function GFBArrowKey()
*--------------------------------------------------------------------*

* eof brow.prg
