*:*********************************************************************
*:
*:        Program: KALEID.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 10/26/88     18:15
*:
*:      Called by: REC_LOCK()
*:               : FILELOCK()
*:               : NET_USE()
*:
*:      Draws a pretty kaleidoscope while the user
*:      waits for the file/record to become available
*:
*:     Documented: 12/26/88 at 18:05                SNAP! version 3.10
*:*********************************************************************
PARAMETER waitmsg
PRIVATE newcolor, mleft
mleft = int((37 - len(waitmsg)) / 2)
IF firstloop
   firstloop = .F.
   STORE 1 TO box_no
   oldcolor = SETCOLOR()
   color_str = 'w/w w/n w/bgw/rbw/r w/grw/b w/g '
   Waiton('Waiting for ' + waitmsg + '... press Esc to abort wait')
   buffer = SAVESCREEN(11, mleft, 13, 79 - mleft)
ELSE
   box_no = box_no + 1
   newcolor = SUBSTR(color_str,INT((SECONDS()-INT(SECONDS()))*8)*4+1,4)
   SETCOLOR(newcolor)
   @ 12-box_no, mleft-box_no+1 TO 12+box_no, 78 - mleft + box_no
   INKEY(.1)
   IF box_no = 11
      box_no = 1
      CLEAR
      RESTSCREEN(11, mleft, 13, 79 - mleft, buffer)
   ENDIF
ENDIF
RETURN
*: EOF: KALEID.PRG
