*:*********************************************************************
*:
*:        Program: POPNOTE.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 11/20/89 - added field insertion for merge mailing
*:                 12/12/89 - added upper/lowercase block options
*:
*:  Procs & Fncts: FILEWRITE()
*:               : NOTEPAD_HD
*:               : GRUMPFUN()
*:               : NOTEHELP()
*:               : GETVAR()
*:               : PROBLEM()
*:               : NEWFILE()
*:               : STAT_MSG()
*:               : SETTINGS()
*:               : STRIPDIR()
*:               : GETFILE()
*:               : SWAPCURS()    (Assembler function in CURSOR.ASM)
*:               : CURS_TOP()    (Assembler function in CURSTOP.ASM)
*:               : CURS_BOT()    (Assembler function in CURSBOT.ASM)
*:               : NEWCURS()     (Assembler function in CURSNEW.ASM)
*:
*:     Documented: 01/09/89 at 09:00                 SNAP! version 3.10
*:*********************************************************************

** Default hot key is F4

PARAMETERS gfproc, line, var
PRIVATE oldcolor, oldscr, oldinsert, workfile, gfstatus, handle, key,       ;
        start_row, rel_row, rel_col, temptext, wordwrap, mfile, srchstr,    ;
        repstr, rep_var, mainloop, pg_length, page, lmargin, rmargin,       ;
        curr_line, printline, linewidth, quickquit, hotkey, firstloop,      ;
        filechange, mdir, switchfile, moldrow, moldcol, mcurstop, mcursbot, ;
        sel, marker1, marker2, copyblock, oldtext, condition, num_flds, ;
        curr_elem, xx, yy, zz, work_area, cursbottom, block_[7], blockmarks

*
*  what a motley bunch of memory variables!!!
*
*  Declare memvar NOTEFILE as PUBLIC in the calling routine
*  to retain working filename upon re-entry to notepad.
*
*  Declare memvars CURR_DIR and WILDCARD as PUBLIC in calling
*  routine to retain working directory and wildcard upon
*  re-entry to the notepad.
*
*  To print a one-line header at the top of each page
*  (containing filename, date, and page number), declare
*  memvar NOTEHEAD as PUBLIC in the calling routine.
*
*  You can also send the printer a set-up string prior to
*  printing by defining such a set-up string in character
*  variable SETUP_STR prior to calling the notepad.  In the
*  same manner, a character variable RESET_STR may be used
*  to reset the printer after printing.
*

** save current screen coordinates
moldrow = ROW()
moldcol = COL()
IF PCOUNT() > 0
   hotkey = LASTKEY()
   SET KEY hotkey TO
ELSE
   hotkey = 0
ENDIF
num_flds = FCOUNT()          && used for field insert feature
pastebuff = []               && buffer to be pasted in

** initialize fields array if a database is open (FCOUNT() > 0)
IF num_flds > 0
   work_area = SELECT()      && save current work area
   SELECT 0
   max_area = SELECT() - 1   && determine highest numbered active work area
   num_flds = 0              && accumulator for total number of fields
   FOR xx = 1 TO max_area
      SELECT(xx)             && switch work areas
      num_flds = num_flds + FCOUNT()
   NEXT
   PRIVATE fields[num_flds]  && this will be the master fields array
   curr_elem = 1             && place holder in array FIELDS
   FOR xx = 1 TO max_area
      SELECT(xx)
      yy = FCOUNT()
      IF yy > 0                && make sure there are fields in this work area
         PRIVATE tempflds[yy]  && declare temporary array to hold these fields
         AFIELDS (tempflds)    && fill it
         *** add the name of the alias to each of these fields
         FOR zz = 1 TO yy
            tempflds[zz] = ALIAS() + '->' + tempflds[zz]
         NEXT
         *** copy these fields to the master fields array
         *** starting at the next undefined element (CURR_ELEM)
         ACOPY(tempflds, fields, 1, yy, curr_elem)
         curr_elem = curr_elem + yy    && increment placeholder
      ENDIF
   NEXT
   SELECT(work_area)         && pop back to the current work area
ENDIF

** save current environment
curr_dir = IF(TYPE('curr_dir') = 'C', curr_dir, '\' + ;
   IF(LEN(CURDIR())>0, CURDIR()+'\', ''))
wildcard = IF(TYPE('wildcard') = 'C', wildcard, '*.*')
SET SCOREBOARD OFF            && this has got to be the dumbest dBASE feature!
oldcolor = SETCOLOR('W/B,I')  && save previous color settings
oldscr   = SAVESCREEN(0, 0, 24, 79)    && save screen
mcurstop = curs_top()         && get the current cursor starting scan line
mcursbot = curs_bot()         && get the current cursor ending scan line
oldinsert = READINSERT(.T.)   && toggle insert mode on, save current status

** establish bottom cursor scan line, which will be 13 for mono, 7 for color
** this figure actually should be different for CGA and EGA, so I'll have to
** write another little Assembler routine to differentiate between the two
cursbottom = IF(ISCOLOR(), 7, 13)
NewCurs(0, cursbottom)        && set cursor to large block

** initialize the variables
STORE 0 TO rel_row, rel_col, blockmarks
STORE 1 TO start_row, lmargin
STORE 80 TO rmargin, linewidth
STORE 60 TO pg_length
STORE .T. TO mainloop, wordwrap
STORE .F. TO filechange
STORE '' TO filename

block_[1] = 'Move Block'
block_[2] = 'Copy Block'
block_[3] = 'Kill Block'
block_[4] = 'Print Block'
block_[5] = 'Uppercase'
block_[6] = 'Lowercase'
block_[7] = 'Erase Markers'

** paint note pad box
@ 0, 0, 24, 79 BOX 'ķӺ '
@ 22,00 SAY CHR(199)
@ 22,01 SAY REPLICATE( CHR(196), 78)
@ 22,79 SAY CHR(182)
** if the variable NOTEFILE exists, use that as the start-up filename
** otherwise prompt the user for it
IF TYPE('notefile') = 'C'
   filename = notefile
ELSE
   filename = UPPER(GetVar('ENTER FILE NAME TO EDIT:','C'))
   ** if they hit Enter without a filename, give them pop-up list
   filename = IF(EMPTY(filename), GetFile(.T.), filename)
ENDIF
IF ! EMPTY(filename)  && i.e., user did not ESC out of the file directory
   SETCOLOR('+W/B')
   @ 00,67 SAY 'Alt-H = Help'
   SETCOLOR('+W/N')
   NewFile()

   ** begin main edit loop
   DO WHILE mainloop
      SCROLL(01, 01, 21, 78, 0)
      NewCurs(cursbottom - 1, cursbottom)      && equivalent to SET CURSOR ON
      firstloop = .T.      && used during idle mode in Grumpfun() below
      workfile = MEMOEDIT(temptext, 1, lmargin, 21, MIN(rmargin,78), .T., ;
         'gfeditfunc', linewidth, '', start_row, rel_col, rel_row, rel_col)

      ** various actions to take upon exiting MEMOEDIT()
      DO CASE

         CASE KEY = 286       && Alt-A: append new file and continue
            IF FILE(mfile)
               temptext = STRTRAN(workfile, CHR(26)) + MEMOREAD(mfile)
            ELSEIF LEN(TRIM(mfile)) > 0
               Problem('File ' + mfile + ' not found')
            ENDIF

         CASE blockmarks = 3          && block command
            blockmarks = 0
            marker1 = AT(CHR(254), workfile)
            marker2 = RAT(CHR(254), workfile)
            DO CASE

               *** Move Block
               CASE sel = 1         && sel was defined at line 443
                  ** copy marked block to scrap buffer
                  copyblock = SUBSTR(workfile, marker1 + 1, marker2-marker1-1)
                  ** first delete marked block
                  workfile = SUBSTR(workfile, 1, marker1-1) + ;
                             SUBSTR(workfile, marker2+1)
                  ** then paste the scrap buffer at the new location
                  temptext = SUBSTR(workfile, 1, AT(CHR(255), workfile) - 1) + ;
                             copyblock + SUBSTR(workfile, AT(CHR(255), workfile) + 1)

               ** Copy Block
               CASE sel = 2         && sel was defined at line 443
                  ** copy marked block to scrap buffer
                  copyblock = SUBSTR(workfile, marker1+1, marker2 - marker1 - 1)
                  ** save text after the marker
                  oldtext   = SUBSTR(workfile, AT(CHR(255), workfile) + 1)
                  ** add in the marked block
                  temptext = SUBSTR(workfile, 1, AT(CHR(255), workfile) - 1) + ;
                             copyblock + oldtext

               ** Kill Block
               CASE sel = 3         && sel was defined at line 443
                  temptext = SUBSTR(workfile, 1, marker1-1) + ;
                             SUBSTR(workfile, marker2+1)

               ** Print Block
               CASE sel = 4         && sel was defined at line 443
                  printit(UPPER(SUBSTR(workfile, marker1 + 1, ;
                          marker2 - marker1 - 1)), ".T.")

               ** Uppercase / Lowercase
               CASE sel = 5 .OR. sel = 6         && sel was defined at line 443
                  ** copy marked block to scrap buffer and convert appropriately
                  IF sel = 5       && uppercase
                     copyblock = UPPER(SUBSTR(workfile, marker1 + 1, ;
                                              marker2 - marker1 - 1))
                  ELSE
                     copyblock = LOWER(SUBSTR(workfile, marker1 + 1, ;
                                              marker2 - marker1 - 1))
                  ENDIF
                  temptext = SUBSTR(workfile, 1, marker1-1) + copyblock + ;
                             SUBSTR(workfile, marker2+1)

               CASE sel = 7
                  temptext = workfile

            ENDCASE
            temptext = STRTRAN(temptext, CHR(254), '')  && erase block markers

         CASE KEY = 275      && Alt-R: Search and Replace
            srchstr = TRIM(GetVar('Enter search string:', 'C'))
            ** if user entered null string, skip this procedure
            IF LEN(srchstr) > 0
               repstr = TRIM(GetVar('Enter replacement string:', 'C'))
               rep_var = GetVar('Replace all? (Y/N)','L')
               IF rep_var
                  temptext = STRTRAN(workfile, srchstr, repstr)
               ELSE
                  rep_var  = GetVar('Occurrences to replace:', 'N')
                  if rep_var > 0
                     temptext = STRTRAN(workfile, srchstr, repstr, 1, rep_var)
                  endif
               ENDIF
            ELSE
               temptext = workfile  && so that we retain the working text
            ENDIF

         CASE KEY = 272 .OR. KEY = 287  && Alt-S or Alt-Q: save file
            if len(workfile) > 0 .or. ;
                   (len(workfile) = 0 .and. len(temptext) > 0)
               IF filename = 'TEMPFILE'
                  filename = UPPER(GetVar('Enter file name to save to:','C'))
               ENDIF
               Stat_Msg('Saving ' + filename)
               FileWrite(filename, workfile)
               temptext = workfile
            ENDIF

         CASE KEY = 273            && Alt-W: write to new file
            IF FILE(mfile)
               Problem('File ' + mfile + ' already exists')
            ELSEIF LEN(TRIM(mfile)) > 0
               Stat_Msg('Writing to ' + mfile)
               FileWrite(mfile, workfile)
            ENDIF
            temptext = workfile  && so that we retain the working text

         CASE KEY = 305            && Alt-N: change files
            IF LEN(TRIM(mfile)) > 0
               IF LEN(workfile) = 0   && delete this file handle if no text
                  ERASE (filename)
               ENDIF
               filename = mfile
               NewFile()
               blockmarks = 0          && reset block markers
            ENDIF

         CASE KEY = 281            && Alt-P: print file
            temptext = workfile
            IF ! ISPRINTER()
               Problem('Printer not ready')
            ELSE
               *** establish condition for DO..WHILE printing loop below
               *** this will be changed if user sets a filter
               marker2 = RECNO()
               condition = 'RECNO() == marker2'

               *** If you would like to call the interactive query builder
               *** (SETFILT) to filter out records for mail merge, uncomment
               *** the next code block

   *            marker1 = AT('{', temptext)
   *            IF marker1 > 0
   *               IF GetVar('Print for more than one record (Y/N)', 'L')
   *                  DO setfilt             && establish filter criteria
   *                  condition = '! EOF()'
   *               ENDIF
   *            ENDIF

               printit(workfile, condition)

               *** reset record pointer and turn off filter if database is open
               IF num_flds > 0
                  GO marker2              && defined at the top of this block
                  SET FILTER TO
               ENDIF

               *SET MARGIN TO 0
            ENDIF

         OTHERWISE
            temptext = workfile  && to retain the working text

      ENDCASE
      IF READINSERT()   && if still in Insert mode, switch cursor back to small
         SwapCurs()
      ENDIF
   ENDDO

   ** delete last file handle if there is no text
   IF FILE(filename)
      handle = FOPEN(filename)
      temptext = FSEEK(handle, 0, 2)
      FCLOSE(handle)
      IF temptext = 0
         ERASE (filename)
      ENDIF
   ENDIF

   ** if NOTEFILE variable is being used, we want to save the last filename
   ** so that the user can pop directly back to this file if necessary
   notefile = filename
ENDIF

** reset environment to previous state
IF hotkey != 0
   SET KEY hotkey TO popnote
ENDIF
SETCOLOR(oldcolor)
RESTSCREEN(0, 0, 24, 79, oldscr)
@ moldrow,moldcol SAY ''
NewCurs(mcurstop, mcursbot)         && restore previous cursor
READINSERT(oldinsert)
RETURN

*-------------------------------------------
* printit(): print all or part of memo
*-------------------------------------------
FUNCTION printit
PARAMETER mtext, condition
PRIVATE page, linewidth, printline, currline, lines, oldtext, marker1, marker
SET MARGIN TO lmargin
NewCurs(32, 0)    && equivalent to SET CURSOR OFF
page = 1
linewidth = rmargin - lmargin + 1
Stat_Msg('Printing ' + filename +', page ' + LTRIM(STR(page)))
SET DEVICE TO PRINT
IF TYPE('setup_str') != 'U'  && if defined in calling routine
   @ PROW(),PCOL() SAY setup_str
ENDIF
*** begin main loop
lines = MLCOUNT(mtext, linewidth)
DO WHILE &condition.
   IF TYPE('notehead') != 'U'   && if defined in calling routine
      notepad_hd()
   ENDIF
   currline = 1
   DO WHILE currline <= lines .AND. INKEY() <> 27
      printline = MEMOLINE(mtext, linewidth, currline)

      *** check for embedded fieldname
      *
      marker1 = AT('{', printline)
      marker = AT('}', printline)
      IF marker1 > 0 .and. marker > marker1 + 1
         DO WHILE marker1 > 0
            oldtext = SUBSTR(printline, marker1 + 1, marker - marker1 - 1)
            *** convert this field appropriately
            DO CASE
               CASE TYPE(oldtext) = 'N'
                  oldtext = LTRIM(STR(&oldtext))
               CASE TYPE(oldtext) = 'L'
                  oldtext = IF(&oldtext, 'Yes', 'No')
               CASE TYPE(oldtext) = 'D'
                  oldtext = DTOC(&oldtext)
               CASE TYPE(oldtext) $ 'UM'
                  oldtext = ""
               OTHERWISE
                  oldtext = TRIM(&oldtext)
            ENDCASE
            printline = SUBSTR(printline, 1, marker1-1) + oldtext + ;
                        SUBSTR(printline, AT('}', printline) + 1)
            marker1 = AT('{', printline)
            marker = AT('}', printline)
         ENDDO
      ENDIF
      *
      ***

      @ PROW()+1,0 SAY TRIM(printline)
      IF PROW() = pg_length - 1
         page = page + 1
         SET DEVICE TO SCREEN
         Stat_Msg('Printing ' + filename + ', page ' + LTRIM(STR(page)))
         SET DEVICE TO PRINT
         IF TYPE('notehead') != 'U'
            notepad_hd()
         ELSE
            EJECT
         ENDIF
      ENDIF
      currline = currline + 1
   ENDDO
   EJECT
   *** if no database open, fall out
   IF num_flds = 0
      EXIT
   ELSE
      SKIP
   ENDIF
ENDDO     && end main loop
IF TYPE('reset_str') != 'U'  && if defined in calling routine
   @ PROW(),PCOL() SAY reset_str
ENDIF
SET DEVICE TO SCREEN
IF LASTKEY() = 27
   Stat_Msg('Printing aborted')
ENDIF
RETURN []

*-------------------------------------------
* gfeditfunc(): user function for MEMOEDIT()
*-------------------------------------------
FUNCTION gfeditfunc
PARAM gfstatus, gfline, gfcol
PRIVATE ret_val, scrnbuff, curses_top, curses_bot, buffer
ret_val = 0
KEY = LASTKEY()
SETCOLOR('W/B')
DO CASE
CASE gfstatus = 3              && start-up mode
   @ 23,68 SAY '<Wrap>' + IF(READINSERT(), '<Ins>', '')
   IF READINSERT()
      SwapCurs()
   ENDIF
CASE gfstatus = 0          && idle
   IF firstloop .AND. ! filechange    && on 1st loop we don't want the asterisk
      firstloop = .F.
      @ 0,65 SAY CHR(196)
   ELSEIF ! filechange
      ** file was changed if they hit Backspace, Enter, or printable characters
      filechange = (key = 8 .OR. key = 13 .OR. key > 31)
      IF filechange
         @ 0,65 SAY '*'
      ENDIF
   ENDIF
   Settings()
   Stat_Msg(StripDir(filename))
OTHERWISE
   DO CASE

      CASE KEY = 22            && toggled Insert on/off
         ins_mode = READINSERT()
         @ 23,74 SAY IF(ins_mode, SPACE(5), '<Ins>')
         SwapCurs()
         ret_val = 22

      CASE KEY = 286           && Alt-A: append file
         mfile = GetFile(.f.)
         filechange = .T.
         ret_val = 23

      CASE KEY = 304           && Alt-B: mark a block
         IF blockmarks = 2
            Save_Pos()
            ** must get cursor status because ACHOICE() screws with it
            curses_top = curs_top()         && get cursor starting scan line
            curses_bot = curs_bot()         && get cursor ending scan line
            SETCOLOR('+W/R, I')
            scrnbuff = shadowbox(08, 32, 16, 46, 2)
            sel = ACHOICE(09, 33, 15, 45, block_, .T.)
            ByeByeBox(scrnbuff)
            SETCOLOR('+W/N')

            ** if moving or copying block, we must mark current position with
            ** CHR(255), which looks for all intents/purposes like a space
            IF sel = 1 .OR. sel = 2    && move/copy block
               KEYBOARD CHR(255)+CHR(23)
            ENDIF
            blockmarks = IF(sel > 0, 3, 2)
            ret_val = IF(sel > 2, 23, 32)
            NewCurs(curses_top, curses_bot)    && restore cursor properly
         ELSE
            blockmarks = blockmarks + 1

            ** switch to Insert mode (if not already) so as not
            ** overwrite text, then stuff keyboard w/ Insert key
            ** to switch back -- this is the only way I found to do it
            IF ! READINSERT()
               READINSERT(.T.)
               SwapCurs()
               KEYBOARD CHR(254) + CHR(22)
            ELSE
               KEYBOARD CHR(254)
            ENDIF
            ret_val = 32
         ENDIF

      CASE KEY = 289           && Alt-F: insert field
         IF num_flds > 0
            ** must get cursor status because ACHOICE() screws with it
            curses_top = curs_top()         && get cursor starting scan line
            curses_bot = curs_bot()         && get cursor ending scan line
            scrnbuff = shadowbox(4, 29, 18, 50, 2, 'Fields')
            sel = ACHOICE(5, 30, 17, 49, fields, .T.)
            ByeByeBox(scrnbuff)
            NewCurs(curses_top, curses_bot)    && restore cursor properly
            ** switch to Insert mode (if not already) so as not
            ** overwrite text, then stuff keyboard w/ name of field
            IF sel > 0
               sel = "{" + fields[sel] + "}"
               IF ! READINSERT()
                  READINSERT(.T.)
                  SwapCurs()
                  KEYBOARD sel + CHR(22)
               ELSE
                  KEYBOARD sel
               ENDIF
            ENDIF
         ENDIF

      CASE KEY = 290           && Alt-G: go to line
         rel_row = GetVar('Go to line number:', 'N')
         start_row = rel_row
         ret_val = 23
         
      CASE KEY = 291           && Alt-H: help screen
         NoteHelp()
         ret_val = 32
         
      CASE KEY = 279           && Alt-I: insert buffer
         IF ! EMPTY(pastebuff)
            ** switch to Insert mode (if not already) so as not
            ** overwrite text, then stuff keyboard w/ Insert key
            IF ! READINSERT()
               READINSERT(.T.)
               SwapCurs()
               KEYBOARD pastebuff + CHR(22)
            ELSE
               KEYBOARD pastebuff
            ENDIF
         ENDIF
         ret_val = 32



      CASE KEY = 293           && Alt-K: kut and paste
         buffer = cutnpaste(@oldscr)
         IF LASTKEY() != 27
            pastebuff = buffer
         ENDIF
         ret_val = 32
         
      CASE KEY = 294           && Alt-L: change page length for printing
         pg_length = GetVar('Enter new page length:', 'N')
         ret_val = 32

      CASE KEY = 306           && Alt-M: change margins for printing
         Save_Pos()
         DO WHILE .T.
            lmargin = MAX(GetVar('Enter new left margin:', 'N'), 1)
            trmargin = GetVar('Enter new right margin:', 'N')
            ** if user hit Enter for right margin (0), use previous setting
            rmargin = IF(trmargin = 0, rmargin, trmargin)
            IF rmargin > lmargin
               exit
            ENDIF
            Problem('Illegal margins, try again')
         ENDDO
         linewidth = rmargin - lmargin + 1
         Settings()
         ret_val = 23
         
      CASE KEY = 305           && Alt-N: edit new file
         switchfile = .T.
         IF filechange
            switchfile = GetVar('File changed, exit anyway (Y/N)', 'L')
         ENDIF
         IF switchfile
            STORE 0 TO rel_row, rel_col
            start_row = 1
            mfile = GetFile(.t.)
            filechange = .F.
            ret_val = 23
         ELSE
            ret_val = 32
         ENDIF

      CASE KEY = 281           && Alt-P: print file
         Save_Pos()
         ret_val = 23

      CASE KEY = 272           && Alt-Q: save file and quit
         mainloop = .F.
         ret_val = 23

      CASE KEY = 275           && Alt-R: search and replace
         Save_Pos()
         filechange = .T.
         ret_val = 23

      CASE KEY = 287           && Alt-S: save file
         Save_Pos()
         @ 0,65 SAY CHR(196)   && can remove 'file changed' indicator
         filechange = .F.
         ret_val = 23

      CASE KEY = 276           && Alt-T: toggle Word Wrap
         wordwrap = ! wordwrap
         @ 23,68 SAY IF(wordwrap, '<Wrap>', SPACE(6))
         ret_val = 34
         
      CASE KEY = 303           && Alt-V: View buffer
         scrnbuff = shadowbox(9, 10, 15, 69, 2, 'Scrap Buffer')
         pastebuff = MEMOEDIT(pastebuff, 10, 11, 14, 68, .F.)
         ByeByeBox(scrnbuff)

      CASE KEY = 273           && Alt-W: write text to new file
         Save_Pos()
         mfile = UPPER(GetVar('File name to write to:','C'))
         ret_val = 23
         
      CASE KEY = 301 .OR. KEY = 27     && Alt-X or Esc to exit
         quickquit = .T.
         IF filechange
            quickquit = GetVar('File changed, exit anyway (Y/N)', 'L')
         ELSEIF KEY = 27
            quickquit = GetVar('Abort editing (Y/N)', 'L')
         ENDIF
         IF quickquit
            mainloop  = .F.
            ret_val = 27
         ELSE
            ret_val = 32
         ENDIF
         
      CASE KEY = 277           && Alt-Y: change directory
         mdir = UPPER(GetVar('Enter directory and/or wildcard:', 'C'))
         DO CASE
               
               ** user input wildcard mask only
            CASE AT('.',mdir) > 0 .AND. AT('\',mdir) = 0
               wildcard = mdir

               ** user input directory only
            CASE AT('*',mdir) = 0 .AND. LEN(TRIM(mdir)) > 0
               curr_dir = IF(LEFT(mdir,1) = '\', '', '\') + mdir + ;
                  IF(RIGHT(TRIM(mdir),1) = '\', '', '\')
               wildcard = '*.*'
               ** add new subdirectory to current working filename
               filename = curr_dir + StripDir(filename)
               
               ** user input directory and wildcard mask - parse string
            CASE LEN(TRIM(mdir)) > 0
               wildcard = SUBSTR(mdir, RAT('\',mdir) + 1)
               curr_dir = IF(LEFT(mdir,1) = '\', '', '\') + ;
                  SUBSTR(mdir, 1, RAT('\',mdir))
               ** add new subdirectory to current working filename
               filename = curr_dir + StripDir(filename)

         ENDCASE
         ret_val = 32

   ENDCASE
ENDCASE
SETCOLOR('+W/N')
RETURN (ret_val)

*---------------------------------------
* NoteHelp: display list of active keys
*---------------------------------------
FUNCTION NoteHelp
PRIVATE oldscrn
oldscrn = SAVESCREEN(01, 01, 21, 78)
SETCOLOR('W/B')
SCROLL(01, 01, 21, 78, 0)
@ 2, 7 SAY 'Alt-A  (A)ppend file'
@ 3, 42 SAY 'Alt-B  '+IF(blockmarks<2, 'place (B)lock marker','(B)lock operation')
IF num_flds > 0
   @ 3, 42 SAY 'Alt-F insert (F)ield'
ENDIF
@ 3,  7 SAY 'Alt-G  (G)oto line'
@ 4,  7 SAY 'Alt-H  show (H)elp screen'
@ 4, 42 SAY 'Alt-I  (I)nsert buffer'
@ 5,  7 SAY 'Alt-K  (K)ut and Paste'
@ 5, 42 SAY 'Alt-L  page (L)ength'
@ 6,  7 SAY 'Alt-M  change (M)argins'
@ 6, 42 SAY 'Alt-N  edit (N)ew file'
@ 7,  7 SAY 'Alt-P  (P)rint file'
@ 7, 42 SAY 'Alt-Q  (Q)uit w/ save'
@ 8,  7 SAY 'Alt-R  search and (R)eplace'
@ 8, 42 SAY 'Alt-S  (S)ave file & continue'
@ 9,  7 SAY 'Alt-T  (T)oggle wordwrap on/off    Alt-V  (V)iew buffer contents'
@10,  7 SAY 'Alt-W  (W)rite to file'
@10, 42 SAY 'Alt-X  e(X)it without saving'
@11,  7 SAY 'Alt-Y  change director(Y)'
@12,  7 SAY '^E     Go up one line'
@12, 42 SAY '^X     Go down one line'
@13,  7 SAY '^S     Go left one char'
@13, 42 SAY '^D     Go right one char'
@14,  7 SAY '^A     Go left one word'
@14, 42 SAY '^F     Go right one word'
@15,  7 SAY 'HOME    Go to start of line'
@15, 42 SAY 'END    Go to end of line'
@16,  7 SAY '^HOME   Top corner of window'
@16, 42 SAY '^END   Bottom corner of window'
@17, 7 SAY '^PgUp   Go to start of file'
@17, 42 SAY '^PgDn  Go to end of file'
@18, 7 SAY 'Esc     Abort edit, no save'
@18, 42 SAY '^Y     Delete current line'
SETCOLOR('+GR/N')
@ 1,33 SAY 'MNEMONIC KEYS'
SETCOLOR('*W/B')
@ 21,23 SAY ' Press any key to resume editing '
INKEY(0)
SETCOLOR('+W/N')
RESTSCREEN(01, 01, 21, 78, oldscrn)
RETURN ('')

*----------------------------------------------
* FileWrite: write text to new or existing file
*----------------------------------------------
FUNCTION FileWrite
PARAMETERS gffilename, text
gfstatus = MEMOWRIT(gffilename, TEXT)
IF ! gfstatus
   Problem('Write error - ' + LTRIM(STR(DOSERROR())))
ENDIF
RETURN ('')

*---------------------------------------
* GetVar(): get a variable from the user
*---------------------------------------
FUNCTION GetVar
PARAM msg, vartype
PRIVATE ret_val, keypress
ret_val = ''
SETCOLOR('+W/B')
SCROLL(23, 02, 23, 67, 0)
@ 23,02 SAY msg + ' '
IF vartype = 'L'     && special case for yes/no questions
   do while ! upper(chr(inkey())) $ 'YN'
   enddo
   ret_val = (chr(lastkey()) $ 'Yy')
ELSE
   DO WHILE .T.
      keypress = INKEY(0)
      DO CASE

            * Return - exit loop
         CASE keypress = 13 .OR. keypress = 27
            ret_val = IF(vartype = 'N', VAL(ret_val), ret_val)
            EXIT

            * Backspace or left arrow - scrub last character
         CASE (keypress = 8 .OR. keypress = 19) .AND. LEN(ret_val) > 0
            ret_val = SUBSTR(ret_val, 1, LEN(ret_val)-1)
            @ ROW(),COL()-1 SAY CHR(32)
            @ ROW(),COL()-1 SAY ''

            * Other printable characters
         CASE keypress > 31 .AND. keypress < 127
            ret_val = ret_val + CHR(keypress)
            @ ROW(),COL() SAY CHR(keypress)
      ENDCASE
   ENDDO
ENDIF
Stat_Msg(StripDir(filename))      && clear message
RETURN (ret_val)


*---------------------------------
* Problem(): display error message
*---------------------------------
FUNCTION problem
PARAM msg
SETCOLOR('+W/B')
@ 23,02 SAY strpad(msg,65)
TONE(440,1)
TONE(440,1)
INKEY(2)
SETCOLOR('+W/N')
RETURN ('')

*----------------------------------
* NewFile(): create new file handle
*----------------------------------
FUNCTION NewFile
IF ! FILE(filename)
   handle = FCREATE(filename)
   IF handle = -1
      Problem('File creation error - ' + LTRIM(STR(DOSERROR())))
   ENDIF
   FCLOSE(handle)
ENDIF
temptext = MEMOREAD(filename)
RETURN ('')

*------------------------------------
* Stat_Msg(): display status message
*------------------------------------
FUNCTION Stat_Msg
PARAM msg
SETCOLOR('+W/B')
@ 23,02 SAY strpad(msg,41)
SETCOLOR('+W/N')
RETURN ('')

*----------------------------------------
* notepad_hd: heading when printing file
*----------------------------------------
PROCEDURE notepad_hd
@ 0,0 SAY ''
@ 1,0 SAY StripDir(filename)
Center(1, CMONTH(DATE()) + ' ' + LTRIM(STR(DAY(DATE()))) + ', ' + ;
   STR(YEAR(DATE()), 4), linewidth)
@ 1, linewidth-8 SAY 'Page ' + LTRIM(STR(page))
@ 3, 0 SAY ''
RETURN

*-------------------------------------
* settings(): display settings
*-------------------------------------
FUNCTION Settings
SETCOLOR('W/B')
@ 23,43 SAY strpad('L ' + LTRIM(STR(gfline)), 6)
@ 23,50 SAY strpad('C ' + LTRIM(STR(gfcol + 1)), 4)
@ 23,55 SAY 'LM ' + STR(lmargin,2)
@ 23,61 SAY 'RM ' + STR(rmargin,3)
RETURN ('')

*-------------------------------------------
* stripdir(): remove directory from filename
*-------------------------------------------
FUNCTION stripdir
PARAM gffilename
RETURN (TRIM(SUBSTR(gffilename, RAT('\',gffilename)+1)))

*---------------------------------------------------------------
* save_pos(): save relative cursor location in text for re-entry
*---------------------------------------------------------------
FUNCTION save_pos
** GFLINE and GFCOL were passed to the gfline and
rel_row = gfline
start_row = rel_row
rel_col = gfcol
RETURN ('')

*-------------------------------------------
* getfile(): pop up file directory for user
*-------------------------------------------
FUNCTION getfile
PARAM adding
PRIVATE numfiles, ele, oldscrn, ret_val
numfiles = ADIR(curr_dir + wildcard) + IF(m->adding, 1, 0)
PRIVATE filenames[numfiles],filesizes[numfiles]
oldscrn = SAVESCREEN(0, 0, 24, 79)
SETCOLOR('+W/R,I')
ADIR(curr_dir + wildcard,filenames,filesizes)
IF adding
   AINS(filenames,1)
   AINS(filesizes,1)
   filenames[1] = 'NEW FILE'
   filesizes[1] = 0
ENDIF
FOR ele = 1 TO numfiles
   IF SUBSTR(filenames[ele],AT('.',filenames[ele])+1,3) $ ;
                            'EXE-COM-DBF-NTX-DBT-NDX-OBJ-FRM-LIB-LBL-MEM'
      ADEL(filenames, ele)
      ADEL(filesizes, ele)
      ele = ele - 1
      numfiles = numfiles - 1
   ENDIF
NEXT
shadowbox(2, 29, 16, 50, 2, curr_dir + wildcard)
@ 19, 13, 21, 66 BOX 'Ŀ '
@ 20,15 SAY 'Move highlight bar to desired file and press Enter'
ele = ACHOICE(3, 34, 15, 45, filenames, .T.)
DO CASE
   CASE ele = 0                 && user pressed Esc to abort
      ret_val = ''
   CASE ele = 1 .AND. adding    && user selected 'New File'
      ret_val = curr_dir + UPPER(GetVar('Enter file name:','C'))
   OTHERWISE
      ** must verify that this file is not over 64K - MEMOEDIT() limit
      ** however, you will probably want to decrease this limit!
      IF filesizes[ele] > 65536
         Problem('File is too large - cannot load')
         ret_val = ''
      ELSE
         ret_val = curr_dir + filenames[ele]
      ENDIF
ENDCASE
RESTSCREEN(0, 0, 24, 79, oldscrn)
RETURN (ret_val)


*--------------------------------------------
* pastebuff: paste the current POPNOTE buffer
*--------------------------------------------
PROCEDURE pastebuff
PARAMETER a, b, c
IF TYPE('pastebuff') = "C"
   IF ! EMPTY(pastebuff)
      KEYBOARD pastebuff
   ENDIF
ENDIF
RETURN

*: EOF: POPNOTE.PRG
