*:*********************************************************************
*:
*:        Program: Amt2Chr()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-90, Greg Lief
*:
*:  Last modified: 07/20/90 - changed logic to accommodate millions,
*:                            because Bruce Donaldson has a client who
*:                            sometimes writes checks in the millions
*:                            (too bad they aren't made payable to me!)
*:
*:      Convert numeric to character-string (dollar format), great for
*:      writing checks (make 'em payable to Grumpfish, Inc.)
*:
*:      Syntax:  Amt2Chr(<amount>)
*:
*:  Parameters:  <amount> is the numeric to be converted to words.
*:
*:     Returns:  A character string which is the English equivalent
*:               of <amount>
*:
*:*********************************************************************
FUNCTION Amt2Chr
PARAM mnum
PRIVATE mstring, temp, xx, the_words[27]
the_words[1] = 'One'
the_words[2] = 'Two'
the_words[3] = 'Three'
the_words[4] = 'Four'
the_words[5] = 'Five'
the_words[6] = 'Six'
the_words[7] = 'Seven'
the_words[8] = 'Eight'
the_words[9] = 'Nine'
the_words[10] = 'Ten'
the_words[11] = 'Eleven'
the_words[12] = 'Twelve'
the_words[13] = 'Thirteen'
the_words[14] = 'Fourteen'
the_words[15] = 'Fifteen'
the_words[16] = 'Sixteen'
the_words[17] = 'Seventeen'
the_words[18] = 'Eighteen'
the_words[19] = 'Nineteen'
the_words[20] = 'Twenty'
the_words[21] = 'Thirty'
the_words[22] = 'Forty'
the_words[23] = 'Fifty'
the_words[24] = 'Sixty'
the_words[25] = 'Seventy'
the_words[26] = 'Eighty'
the_words[27] = 'Ninety'
mstring = ''
FOR xx = 6 TO 0 STEP -3
   IF mnum >= 10 ^ xx
      temp = INT (mnum / 10 ^ xx)
      mstring = mstring + Convert_It(temp) + IF(xx = 6, ' Million', ;
                IF(xx = 3, ' Thousand', ''))
      mnum = mnum - temp * 10 ^ xx
      IF mnum > 0
         mstring = mstring + ' '
      ENDIF
   ENDIF
NEXT
IF mnum != INT(mnum)
   mstring = mstring + 'and ' + STR( (mnum - INT(mnum)) * 100, 2) + '/100ths'
ELSE
   mstring = mstring + ' Exactly'
ENDIF
RETURN (mstring)

* end function Amt2Chr()
*--------------------------------------------------------------------*


*******************************************************
*
*     Function: CONVERT_IT()
*
*     Called by AMT2CHR()
*
********************************************************
FUNCTION Convert_It
PARAM mnum
PRIVATE mstring, temp
mstring = ''
IF mnum > 99
   temp = INT (mnum / 100)
   mstring = mstring + the_words[temp] + ' Hundred'
   mnum = mnum - temp * 100
   IF mnum > 0
      mstring = mstring + ' '
   ENDIF
ENDIF
DO CASE
   CASE mnum > 0 .AND. mnum < 20
      mstring = mstring + the_words[mnum]
   CASE mnum > 19
      temp = INT(mnum / 10)
      mstring = mstring + the_words[temp + 18]
      mnum = mnum - temp * 10
      IF mnum != 0
         mstring = mstring + '-' + the_words[mnum]
      ENDIF
ENDCASE
RETURN (mstring)

* end function Convert_It()
*--------------------------------------------------------------------*

* eof $amt2chr.prg
