*:*********************************************************************
*:
*:        Program: BLANKSCR()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 03/03/89     13:25
*:
*:  Blanks the screen to prevent monitor wear and tear during inactivity
*:
*:          Calls: CURS_TOP()    (Assembler function in CURSTOP.ASM)
*:               : CURS_BOT()    (Assembler function in CURSBOT.ASM)
*:               : NEWCURS()     (Assembler function in CURSNEW.ASM)
*:
*:      Documented 03/09/89 at 17:15                SNAP!  version 3.12a
*:*********************************************************************
FUNCTION blankscr
PARAM mdelay
PRIVATE mstart,oldscrn,oldcolor,mcurstop,mcursbot,mrow,mcol,mtop,mbott
mstart = SECONDS()
DO WHILE NEXTKEY() = 0 .AND. SECONDS()-mstart < mdelay
ENDDO
IF NEXTKEY() = 0        && i.e., the DO WHILE loop timed out with no keypress
   mrow = ROW()
   mcol = COL()
   oldscrn = SAVESCREEN(0, 0, 24, 79)
   oldcolor = SETCOLOR('+GR/N')
   mcurstop = Curs_Top()  && save current starting cursor scan line
   mcursbot = Curs_Bot()  && save current ending cursor scan line
   NewCurs(32,0)          && functional equivalent of SET CURSOR OFF
   CLEAR SCREEN           && rather than just CLEAR, which zaps GETs
   mtop = 11
   mbott = 14
   Exbox(11, 25, 14, 53, 1, 0)
   @ 12,27 SAY 'The screen has been saved'
   @ 13,27 SAY 'Push spacebar to continue'
   buffer = SAVESCREEN(mtop, 25, mbott, 53)
   mstart = SECONDS()
   DO WHILE INKEY() = 0
      IF SECONDS()-mstart > 30
         SCROLL(mtop, 25, mbott, 53, 0)
         mtop = IF(mtop > 20, 0, mtop + 1)
         mbott = IF(mbott = 24, 3, mbott + 1)
         RESTSCREEN(mtop, 25, mbott, 53, buffer)
         mstart = SECONDS()
      ENDIF
   ENDDO
   SETCOLOR(oldcolor)
   @ mrow,mcol SAY ''
   NewCurs(mcurstop,mcursbot)
   RESTSCREEN(0, 0, 24, 79, oldscrn)
ENDIF
RETURN (0)

* end function blankscr()
*--------------------------------------------------------------------*

* eof $blank1.prg
