*:*********************************************************************
*:
*:        Program: BLANKSCRN()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 01/23/90 - whoops! forgot to restore cursor location!
*:
*:  Blanks the screen to prevent monitor wear and tear during inactivity
*:  Designed for use with GET-IT's N_NOKEY() function
*:
*:  GET-IT is a trademark of Communications Horizons.
*:
*:      Documented 03/09/89 at 17:15                SNAP!  version 3.12a
*:*********************************************************************
FUNCTION blankscrn
PRIVATE oldscrn, oldcolor, mtop, mbott, savebuff, mstart, mrow, mcol, ;
        mcurstop, mcursbot
mrow = ROW()
mcol = COL()
mcurstop = Curs_Top()  && save current starting cursor scan line
mcursbot = Curs_Bot()  && save current ending cursor scan line
NewCurs(32,0)          && functional equivalent of SET CURSOR OFF
oldscrn = SAVESCREEN(0, 0, 24, 79)
oldcolor = SETCOLOR('RB/N')
CLEAR SCREEN
mtop = 10
mbott = 13
Exbox(mtop, 25, mbott, 53, 1, 0)
@ mtop+1,27 SAY 'The screen has been saved'
@ mtop+2,27 SAY 'Push spacebar to continue'
savebuff = SAVESCREEN(mtop, 25, mbott, 53)
mstart = SECONDS()
DO WHILE INKEY() = 0
   IF SECONDS()-mstart > 30
      SCROLL(mtop, 25, mbott, 53, 0)
      mtop = IF(mtop > 20, 0, mtop + 1)
      mbott = IF(mbott = 24, 3, mbott + 1)
      RESTSCREEN(mtop, 25, mbott, 53, savebuff)
      mstart = SECONDS()
   ENDIF
ENDDO
RESTSCREEN(0, 0, 24, 79, oldscrn)
SETCOLOR(oldcolor)
@ mrow,mcol SAY ''
NewCurs(mcurstop,mcursbot)
RETURN(0)

* end function blankscrn()
*--------------------------------------------------------------------*

* eof $blank2.prg
