*:*********************************************************************
*:
*:        Program: BLANKSCR2()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:
*:  Blanks the screen to prevent monitor wear and tear during inactivity
*:
*:          Calls: CURS_TOP()    (Assembler function in CURSTOP.ASM)
*:               : CURS_BOT()    (Assembler function in CURSBOT.ASM)
*:               : NEWCURS()     (Assembler function in CURSNEW.ASM)
*:               : GFRAND()      (function in $RAND.PRG)
*:
*:*********************************************************************
FUNCTION blankscr2
PARAM mdelay
PRIVATE mstart, oldscrn, oldcolor, mcurstop, mcursbot, mrow, mcol, mtop, mbott
mstart = SECONDS()
DO WHILE NEXTKEY() = 0 .AND. SECONDS()-mstart < mdelay
ENDDO
IF NEXTKEY() = 0        && i.e., the DO WHILE loop timed out with no keypress
   **** the following code displays a dancing smiley-face
   mrow = ROW()
   mcol = COL()
   oldscrn = SAVESCREEN(0, 0, 24, 79)
   oldcolor = SETCOLOR('+GR/N')
   mcurstop = Curs_Top()  && save current starting cursor scan line
   mcursbot = Curs_Bot()  && save current ending cursor scan line
   NewCurs(32,0)          && functional equivalent of SET CURSOR OFF
   CLEAR SCREEN           && rather than just CLEAR, which zaps GETs
   mtop = gfrand(25)
   mbott = gfrand(80)
   mstart = SECONDS()
   @ mtop, mbott SAY CHR(2)
   DO WHILE INKEY() = 0
      IF SECONDS()-mstart > 2.5
         SCROLL(mtop, mbott, mtop, mbott, 0)
         mtop = gfrand(25)
         mbott = gfrand(80)
         @ mtop, mbott SAY CHR(2)
         mstart = SECONDS()
      ENDIF
   ENDDO
   SETCOLOR(oldcolor)
   @ mrow,mcol SAY ''
   NewCurs(mcurstop,mcursbot)
   RESTSCREEN(0, 0, 24, 79, oldscrn)
ENDIF
RETURN (0)

* end function blankscr2()
*--------------------------------------------------------------------*

* eof $blank3.prg
