*:*********************************************************************
*:
*:        Program: BLANKSCR3()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:
*:  Blanks the screen to prevent monitor wear and tear during inactivity
*:
*:          Calls: CURS_TOP()    (Assembler function in CURSTOP.ASM)
*:               : CURS_BOT()    (Assembler function in CURSBOT.ASM)
*:               : NEWCURS()     (Assembler function in CURSNEW.ASM)
*:               : GFRAND()      (function in $RAND.PRG)
*:
*:*********************************************************************
FUNCTION blankscr3
PARAM mdelay
PRIVATE mstart, oldscrn, oldcolor, mcurstop, mcursbot, mrow, mcol, ;
        mmrow, mmcol, xx, buffer, spaces_[45], kounter
AFILL(spaces_, -1)
mstart = SECONDS()
DO WHILE NEXTKEY() = 0 .AND. SECONDS()-mstart < mdelay
ENDDO
IF NEXTKEY() = 0        && i.e., the DO WHILE loop timed out with no keypress
   mrow = ROW()
   mcol = COL()
   oldscrn = SAVESCREEN(0, 0, 24, 79)
   oldcolor = SETCOLOR("+BG/N")
   mcurstop = Curs_Top()  && save current starting cursor scan line
   mcursbot = Curs_Bot()  && save current ending cursor scan line
   NewCurs(32,0)          && functional equivalent of SET CURSOR OFF
   CLEAR SCREEN           && rather than just CLEAR, which zaps GETs
   STORE 0 TO key, kounter
   DO WHILE key = 0
      kounter = IF(kounter < 45, kounter + 1, 1)
      xx = gfrand(2000)
      IF spaces_[kounter] > -1
         SETCOLOR("+W/N")
         mmrow = int(spaces_[kounter] / 80)
         mmcol = int(spaces_[kounter] % 80)
         IF gfrand(100) < 45
            @ mmrow, mmcol SAY CHR(250)
            key = MAX(INKEY(.15), key)
         ELSE
            @ mmrow, mmcol SAY CHR(04)
            key = MAX(INKEY(.12), key)
            @ mmrow, mmcol SAY CHR(254)
            key = MAX(INKEY(.12), key)
            @ mmrow, mmcol SAY CHR(15)
            key = MAX(INKEY(.12), key)
         ENDIF
         @ mmrow, mmcol SAY CHR(32)
      ENDIF
      SETCOLOR("+BG/N")
      spaces_[kounter] = xx
      @ int(xx / 80), int(xx % 80) SAY CHR(250)
      key = MAX(INKEY(.01), key)
   ENDDO
   SETCOLOR(oldcolor)
   @ mrow,mcol SAY []
   NewCurs(mcurstop,mcursbot)
   RESTSCREEN(0, 0, 24, 79, oldscrn)
ENDIF
RETURN (0)

* end function blankscr3()
*--------------------------------------------------------------------*

* eof $blank4.prg
