*:*********************************************************************
*:
*:        Program: $BLINDS.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-89, Greg Lief
*:  Last modified: 01/04/90 - changed logic to write screen buffers
*:                            to disk file rather than using macros
*:                            (to appease Al Acker!)
*:
*:  Procs & Fncts: BLINDOPEN()
*:               : BLINDCLOSE()
*:
*:*********************************************************************

*!*********************************************************************
*!
*!       Function: BLINDOPEN()
*!
*!       Purpose:  Draw title screen using blinds effect
*!
*!       NOTE:     Title screen must be pre-saved using SAVE_DRAPE()
*!
*!       Syntax:   Blindopen(<name of screen file>, [<delay>])
*!                 Default delay is 5
*!
*!*********************************************************************
FUNCTION blindopen
PARAM mfile, delay
PRIVATE handle, screen_[80], buffer, xx, yy
delay = IF(PCOUNT() = 1, 5, delay)
IF FILE(mfile)
   buffer = SPACE(50)
   handle = FOPEN(mfile)
   FOR xx = 1 TO 80
      FREAD(handle, @buffer, 50)
      screen_[xx] = SUBSTR(buffer, 1, 50)
   NEXT
   FCLOSE(handle)
   FOR xx = 0 TO 9
      FOR yy = 0 TO 7
         RESTSCREEN(0, yy * 10 + xx, 24, yy * 10 + xx, screen_[yy*10 + xx + 1])
      NEXT
      FOR yy = 1 TO delay
      NEXT
   NEXT
ENDIF
RETURN('')

* end function BlindOpen()
*--------------------------------------------------------------------*


*!*********************************************************************
*!
*!       Function: BLINDCLOSE()
*!
*!       Purpose:  Clear screen using blinds effect
*!
*!       Syntax:   BlindClose([<delay>])
*!                 Default delay is 10
*!
*!*********************************************************************
FUNCTION blindclose
PARAM delay
PRIVATE xx, yy
delay = IF(PCOUNT() = 0, 10, delay)
FOR xx = 9 TO 0 STEP -1
   FOR yy = 7 TO 0 STEP -1
      SCROLL(0, yy * 10 + xx, 24, yy * 10 + xx, 0)
   NEXT
   FOR yy = 1 TO delay
   NEXT
NEXT
RETURN('')

* end function BlindClose()
*--------------------------------------------------------------------*

* eof $blinds.prg
