*:*********************************************************************
*:
*:        Program: BOX_TITLE()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 05/08/89
*:
*:      Called by: EXBOX()          (Function in FEXBOX.PRG)
*:                 POPBOX()         (Function in FPOPBOX.PRG)
*:                 DROPBOX()        (Function in FDROPBOX.PRG)
*:                 SHADOWBOX()      (Function in FSHADBOX.PRG)
*:
*:     NOT FOR USE AS A STAND-ALONE FUNCTION!!!
*:
*:     Draws box title with frame
*:
*:     Documented: 05/08/89 at 14:35                 SNAP! version 3.10
*:*********************************************************************
FUNCTION Box_Title
PARAM use_xbar
PRIVATE midpoint

** do not use cross-bar if that parameter was not passed
use_xbar = (IF(PCOUNT() = 0, .F., use_xbar))

** variables MRTCOL, MLFCOL, MUPROW will already have been defined in
** the calling routine (EXBOX(), POPBOX(), DROPBOX(), or SHADOWBOX())
midpoint = mlfcol + (INT(mrtcol - mlfcol + 1) / 2)

IF use_xbar
   @ muprow + 1, midpoint - (INT(LEN(mtitle) / 2)) SAY mtitle
   @ muprow + 2, mlfcol SAY SUBSTR(bx_string, 12, 1) + ;
                   REPLICATE(SUBSTR(bx_string, 2, 1),  ;
                   (mrtcol - mlfcol - 1)) + SUBSTR(bx_string, 13, 1)
ELSE
   @ muprow, midpoint - (INT(LEN(mtitle) / 2)) - 2 SAY ;
        SUBSTR(bx_string, 10, 1) + ' ' + mtitle + ' ' + SUBSTR(bx_string, 11, 1)
ENDIF
RETURN(0)

* end function box_title()
*--------------------------------------------------------------------*

* eof $boxtitl.prg
