*:*********************************************************************
*:
*:        Program: BOXTYPE()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 05/08/89
*:
*:      Returns string with which to draw a box
*:
*:      Called by: EXBOX()       (Function in FEXBOX.PRG)
*:                 POPBOX()      (Function in FPOPBOX.PRG)
*:                 DROPBOX()     (Function in FDROPBOX.PRG)
*:                 SHADOWBOX()   (Function in FSHADBOX.PRG)
*:                 HELP / HELPDEV
*:
*:     Documented: 12/26/88 at 18:04                SNAP! version 3.10
*:*********************************************************************
FUNCTION Boxtype
PARAM bx_type
PRIVATE bx_string
** characters 10 and 11 in each string are used for the title frame (optional)
**            "Ĵ title goes here "
** characters 12 and 13 are used for the crossbar (optional)
**             Ŀ
**                         title goes here            
**             Ĵ
**                                                    
DO CASE
   CASE bx_type = 1
      bx_string = 'ͻȺ ̹'
   CASE bx_type = 2
      bx_string = 'Ŀ ô'
   CASE bx_type = 3
      bx_string = '͸Գ Ƶ'
   CASE bx_type = 4
      bx_string = 'ķӺ Ƕ'
   CASE bx_type = 5
      bx_string = ' '
   OTHERWISE
      bx_string = '             '
ENDCASE
RETURN (bx_string)

* end function BoxType()
*--------------------------------------------------------------------*

* eof $boxtype.prg
