*:*********************************************************************
*:
*:        Program: CENTER().PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 02/06/89     17:36
*:
*:  Procs & Fncts: CENTER()
*:
*:     Documented: 12/26/88 at 18:04                SNAP! version 3.10
*:*********************************************************************
FUNCTION Center
*-------------------------------------------------------------------
* parameters:  row = row at which to display or print string
*              string = character string to be displayed
*              row_len = length of row (default is 80 - up to 255)
*-------------------------------------------------------------------
PARAM row,string,row_len
IF PCOUNT()<3                 && user did not pass length parameter
   row_len = 80               && use default of 80
elseif TYPE('row_len')!='N'   && user passed a non-numeric length!
   SET DEVICE TO SCREEN
   Err_msg('Length parameter for CENTER() must be type numeric')
   RETURN ''
ENDIF
IF LEN(string) < row_len
   @ row,INT((row_len-LEN(string))/2) SAY string
ELSE
   SET DEVICE TO SCREEN
   Err_msg('Length of string passed to CENTER() exceeds length of row')
ENDIF
RETURN ''

* end function Center()
*--------------------------------------------------------------------*

* eof $center.prg
