*:*********************************************************************
*:
*:        Program: $CLRSCR.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:                 Methods #8 and #9 written and provided courtesy of:
*:                     Laurent Maggiore
*:                     150 Bd. Poincar
*:                     06160 Juan-Les_Pins
*:                     FRANCE
*:
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 04/20/89
*:
*:  Procs & Fncts: CLRSCR()
*:               : CLEARIT()
*:
*:*********************************************************************
FUNCTION clrscr
PARAM clr_type, delay
PRIVATE xx
clr_type = IIF(PCOUNT() = 0, 1, clr_type)
delay = IIF(PCOUNT() < 2, 20, delay)
DO CASE
CASE clr_type = 1       && window shade pulled down
   FOR xx = 0 TO 24
      clearit(xx,0,xx,79)
   NEXT
CASE clr_type = 2       && window shade yanked up
   FOR xx = 24 TO 0 step -1
      clearit(xx,0,xx,79)
   NEXT
CASE clr_type = 3       && barn door to the right 
   FOR xx = 0 TO 79
      clearit(0,xx,24,xx)
   NEXT
CASE clr_type = 4       && barn door to the left
   FOR xx = 79 TO 0 step -1
      clearit(0,xx,24,xx)
   NEXT
CASE clr_type = 5       && curtains opening
   FOR xx = 40 TO 79
      SCROLL(00, 79-xx, 24, 79-xx, 0)
      clearit(0,xx,24,xx)
   NEXT
CASE clr_type = 6       && curtains closing
   FOR xx = 79 TO 40 step -1
      SCROLL(00, 79-xx, 24, 79-xx, 0)
      clearit(0,xx,24,xx)
   NEXT
CASE clr_type = 7       && camera lens
    mrow = 0
    FOR xx = 0 TO 33 STEP 3
        SCROLL(mrow, xx, mrow, 79 - xx, 0)
        SCROLL(24 - mrow, xx, 24 - mrow, 79 - xx, 0)
        SCROLL(mrow, xx, 24 - mrow, xx + 3, 0)
        clearit(mrow, 76 - xx, 24 - mrow, 79 - xx)
        mrow = mrow + 1
     NEXT
     SCROLL(mrow, 37, mrow, 42, 0)
CASE clr_type = 8       && diagonal
   FOR xx = 0 TO 79
      SCROLL(INT(xx/3.2), xx, 24, xx, 0)
      SCROLL(0, 79 - xx, 24 - INT(xx/3.2), 79 - xx, 0)
      FOR yy = 0 TO 10
      NEXT
   NEXT
CASE clr_type = 9       && vertical halves
   FOR xx = 0 TO 24
      buffer = SAVESCREEN(xx, 0, 23, 39)
      SCROLL(xx, 0, xx, 39, 0)
      IF xx < 24
        RESTSCREEN(xx+1, 0, 24, 39, buffer)
      ENDIF
      buffer = SAVESCREEN(1, 40, 24-xx, 79)
      SCROLL(24-xx, 40, 24-xx, 79, 0)
      IF xx < 24
        RESTSCREEN(0, 40, 23-xx, 79, buffer)
      ENDIF
      FOR yy = 1 TO 25
      NEXT
   NEXT
ENDCASE
RETURN ('')

* end function ClrScr()
*--------------------------------------------------------------------*


*!*********************************************************************
*!
*!       Function: CLEARIT()
*!
*!*********************************************************************
FUNCTION clearit
PARAM t, l, b, r
PRIVATE delayloop
SCROLL(t, l, b, r, 0)
FOR delayloop = 1 TO delay
NEXT
RETURN ('')

* end function ClearIt()
*--------------------------------------------------------------------*

* eof $clrscr.prg
