*:*********************************************************************
*:
*:        Program: $DRAPES.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 01/04/90 - changed logic to write screen buffers
*:                            to disk file rather than using macros
*:
*:  Procs & Fncts: PULL_DRAPE()
*:               : SAVE_DRAPE()
*:
*:      Documented 04/16/89 at 12:06                SNAP!  version 3.12a
*:*********************************************************************

*!*********************************************************************
*!
*!       Function: PULL_DRAPE()
*!
*!       Purpose:  Draw title screen from specified memory file
*!
*!*********************************************************************
FUNCTION pull_drape
PARAM mfile, delay
PRIVATE handle, buffer, xx, yy, mtop, mleft, mbottom, mright, mwidth
delay = IF(PCOUNT() = 1, 20, delay)
IF FILE(mfile)
   handle = FOPEN(mfile)
   ** determine file length
   mlength = FSEEK(handle, 0, 2)
   ** reset pointer to beginning of file
   FSEEK(handle, 0)
   *** we must accommodate for .SCR files created by
   *** if this is not a full screen
   IF mlength != 4000
      buffer = SPACE(4)
      FREAD(handle, @buffer, 4)
      mtop    = BIN2I(SUBSTR(buffer, 1, 1))
      mleft   = BIN2I(SUBSTR(buffer, 2, 1))
      mbottom = BIN2I(SUBSTR(buffer, 3, 1))
      mright  = BIN2I(SUBSTR(buffer, 4, 1))
   ELSE
      mtop = 0
      mleft = 0
      mbottom = 24
      mright = 79
   ENDIF
   PRIVATE screen_[mright - mleft + 1]
   mwidth = ((mbottom - mtop) + 1) * 2
   buffer = SPACE(50)
   FOR xx = 1 TO mright - mleft + 1
      FREAD(handle, @buffer, mwidth)
      screen_[xx] = SUBSTR(buffer, 1, mwidth)
   NEXT
   FCLOSE(handle)
   midpoint = mleft + INT((mright - mleft + 1) / 2) + 1
   FOR xx = midpoint TO mright + 1
      RESTSCREEN(mtop, xx - 1, mbottom, xx - 1, screen_[xx - mleft])
      RESTSCREEN(mtop, mright + 1 + mleft - xx, mbottom, mright + 1 + mleft - xx, ;
                screen_[mright + 2 - xx])
      FOR yy = 1 TO delay
      NEXT
   NEXT
ENDIF
RETURN ('')

* end function Pull_Drape()
*--------------------------------------------------------------------*


*!*********************************************************************
*!
*!       Function: SAVE_DRAPE()
*!
*!       Purpose:  Save title screen to specified memory file
*!
*!*********************************************************************
FUNCTION save_drape
PARAMETER mfile, mtop, mleft, mbottom, mright
PRIVATE buffer, handle, xx, ret_val
ret_val = .F.
handle = FCREATE(mfile)
IF FERROR() = 0
   IF PCOUNT() > 1
      FWRITE(handle, CHR(mtop) + CHR(mleft) + CHR(mbottom) + CHR(mright))
   ELSE
      *** if no coordinates were passed, assume full screen
      mtop = 0
      mleft = 0
      mbottom = 24
      mright = 79
   ENDIF
   ret_val = .T.
   FOR xx = mleft TO mright
      buffer = SAVESCREEN(mtop, xx, mbottom, xx)
      IF FWRITE(handle, buffer) != ((mbottom - mtop) + 1) * 2
         ret_val = .F.
         EXIT
      ENDIF
   NEXT
   FCLOSE(handle)
ENDIF
RETURN ret_val

* end function Save_Drape()
*--------------------------------------------------------------------*

* eof $drapes.prg
