*:*********************************************************************
*:
*:        Program: $EDITHEL.PRG
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-90, Greg Lief
*:
*:  Procs & Fncts: EDITHELP()
*:               : HELP_HEAD()
*:
*:          Calls: NEWCURS()     (Assembler function in CURSNEW.ASM)
*:
*:      Called by: HELP.PRG
*:                 HELPDEV.PRG
*:
*:     Permits editing of help screen text via Alt-E,
*:     or printing thereof via Alt-P
*:
*:*********************************************************************
FUNCTION EditHelp
PARAM status,line,col
PRIVATE mtext, mproc, key
key = lastkey()
do case
case key = 274      && user pressed Alt-E to edit existing help text
   NewCurs(0, IF(ISCOLOR(), 7, 13))   && functional equivalent of SET CURSOR ON
   IF RLOCK()
      REPLACE text WITH MEMOEDIT(text,toprow+1,lt_col+1,botrow-1,rt_col-1,.T.)
      NewCurs(32,0)   && functional equivalent on SET CURSOR OFF
      IF TYPE('fixwindow') != 'U'  && flag set true in HELPDEV.prg
         mtext = TEXT              && used in APPEARANCE
         mproc = 'APPEARANCE'      && to avoid compiling it here
         DO &mproc. with 'E'       && allow editing of help window
      ELSE
         KEYBOARD CHR(27)
      ENDIF
      UNLOCK
   ELSE
      Err_msg('Unable to lock record, text not changed at this time')
   ENDIF
case key = 281  && user pressed Alt-P to print this help screen
   PRIVATE linewidth, helpline, lines, currline, page
   IF ! ISPRINTER()
      Err_msg('Printer not ready')
   ELSE
      Waiton('Now printing help text, press Esc to abort')
      SET DEVICE TO PRINTER
      page = 1
      linewidth = rt_col - lt_col + 1
      lines = MLCOUNT(TEXT, linewidth)
      currline = 1
      DO help_head
      DO WHILE currline <= lines .AND. INKEY() <> 27
         helpline = MEMOLINE(TEXT, linewidth, currline)
         @ PROW()+1,lt_col SAY TRIM(helpline)
         IF PROW() >= 59
            page = page + 1
            DO help_head
         ENDIF
         currline = currline + 1
      ENDDO
      EJECT
      SET DEVICE TO SCREEN
      Waitoff()
   ENDIF
endcase
RETURN (0)

* end function EditHelp()
*--------------------------------------------------------------------*


*----------------------------------------------------
* help_head: heading when printing help screen text
*----------------------------------------------------
FUNCTION help_head
@ 0,0 SAY ''
@ 1,1 SAY UPPER(title)
Center(1, CMONTH(DATE()) + ' ' + LTRIM(STR(DAY(DATE()))) + ', ' + ;
   STR(YEAR(DATE()), 4))
@ 1,72 SAY 'Page ' + LTRIM(STR(page))
@ 3, 0 SAY ''
RETURN []

* end function Help_Head()
*--------------------------------------------------------------------*

* eof $edithel.prg
