*:*********************************************************************
*:
*:        Program: ERR_MSG()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 04/10/89 - changed default colors to white on red
*:
*:  Displays error message and waits for user keypress
*:
*:     Documented: 01/12/89 at  12:58                SNAP! version 3.10
*:*********************************************************************
FUNCTION Err_msg
PARAM msg, boxcolour, textcolour, sound
PRIVATE oldcolor, oldscrn, wid
wid = INT(74 - MAX(LEN(msg), 35)) / 2
sound = IF(PCOUNT() < 4, .T., sound)

** establish box and text colors if not passed as parameters
IF PCOUNT() > 1
   boxcolour = IF(LEN(boxcolour) > 0, boxcolour, IF(ISCOLOR(), 'W/R', 'W/N'))
ELSE
   boxcolour = IF(ISCOLOR(), 'W/R', 'W/N')
ENDIF
IF PCOUNT() < 3
   textcolour = IF(ISCOLOR(), '+W/R', '+W/N')
ENDIF
oldcolor = SETCOLOR(m->boxcolour)
oldscrn = Shadowbox(19, wid, 22, 79-wid, 3, 'ERROR')
SETCOLOR(m->textcolour)
Center(20, msg)
Center(21, "** press any key to continue **")
IF sound
   TONE(60,3)
   TONE(40,3)
ENDIF
INKEY(0)
SETCOLOR(oldcolor)
ByeByeBox(oldscrn)
RETURN []

* end function Err_Msg()
*--------------------------------------------------------------------*

* eof $errmsg.prg
