**********************************************************************
*
*       Function: FadeIn()
*
*         System: GRUMPFISH LIBRARY
*         Author: Greg Lief
*      Copyright (c) 1988-90, Greg Lief
*
*       Syntax: FadeIn(<filename>)
*
*    Parameter: <filename> is a character string representing the name
*               of file in which the screen was saved with Sv_FadeIn().
*
*      Returns: A logical value: .T. if successful, .F. if unsuccessful
*               (the only way I can see it failing is if there are not
*               enough available file handles to open the screen file)
*
*!*********************************************************************
FUNCTION FadeIn
PARAMETER fname
PRIVATE handle, mrow, mcol, buffer, xx, ret_val
handle = FOPEN(fname)
ret_val = .F.
IF handle > -1
   ret_val = .T.
   STORE SPACE(1) TO mrow, mcol
   buffer = SPACE(2)
   FOR xx = 1 to 2000
      FREAD(handle, @mrow, 1)
      FREAD(handle, @mcol, 1)
      FREAD(handle, @buffer, 2)
      RESTSCREEN(ASC(mrow), ASC(mcol), ASC(mrow), ASC(mcol), buffer)
   NEXT
ENDIF
FCLOSE(handle)
RETURN ret_val

* end function FadeIn()
*--------------------------------------------------------------------*

* eof $fadein.prg
