*:*********************************************************************
*:
*:        Program: FALLING.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 03/07/89     12:51
*:
*:  Procs & Fncts: FALLGUY()
*:
*:      Documented 03/07/89 at 12:52                SNAP!  version 3.12a
*:*********************************************************************
FUNCTION fallguy
PARAMETERS mrow, mcol, msg, delay
IF PCOUNT() > 2    && first three parameters MUST be passed!
   PRIVATE curr_row, curr_col, save_it, hold_on
   FOR curr_col = mcol TO mcol + LEN(msg) - 1
      IF SUBSTR(msg,curr_col-mcol+1,1) != CHR(32)
         FOR curr_row = 0 TO mrow
            ** save the screen coordinate that is about to be erased
            save_it = SAVESCREEN(curr_row,curr_col,curr_row,curr_col)
            ** draw falling letter at that location
            @ curr_row,curr_col SAY SUBSTR(msg,curr_col-mcol+1,1)
            IF PCOUNT() < 4   && if no delay passed, use 'twinkle-tones'
               IF curr_row % 3 = 0   && only sound off at every 3rd row 
                  TONE(6000-curr_row*125,1)
               ENDIF
            ELSE
               FOR hold_on = 1 TO delay
               NEXT
            ENDIF
            IF curr_row < mrow
               ** restore affected portion of screen
               RESTSCREEN(curr_row,curr_col,curr_row,curr_col,save_it)
            ENDIF
         NEXT
      ELSE   && a falling space would look pretty stupid, at least to me
         @ mrow,curr_col SAY CHR(32)
      ENDIF
   NEXT
ENDIF
RETURN []

* end function FallGuy()
*--------------------------------------------------------------------*

* eof $fallguy.prg
