*:*********************************************************************
*:
*:        Program: FILELOCK()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 10/29/88     19:45
*:
*:      Attempts to lock file in multi-user environment
*:
*:     Documented: 12/26/88 at 18:04                SNAP! version 3.10
*:*********************************************************************
FUNCTION FileLock
PRIVATE firstloop, box_no, buffer, oldcolor, color_str, ret_val, ;
        oldscrn, key
*------------------------------------------------------
* Variables Used:
*   FIRSTLOOP = flag so that user is asked to wait only on
*               first iteration - set false after that
*   RET_VAL   = value to be returned
*   OLDSCRN   = used to save previous screen if user decides to wait
*
* Variables BOX_NO, BUFFER, OLDCOLOR, COLOR_STR are initialized in
* KALEID.prg, but must be declared private in this routine or else
* KALEID will bomb the second time it is called below.
*
*------------------------------------------------------
IF LEN(ALIAS())=0   && no database in use
   RETURN(.F.)
ENDIF
firstloop = .T.
ret_val = .F.
key = 0
DO WHILE key != 27 .AND. ! ret_val
   IF FLOCK()
      ret_val = .T.
   elseif firstloop
      IF Yes_no('Cannot lock ' + ALIAS() + '.dbf at this time', ;
            'Would you like to wait')
         oldscrn = SAVESCREEN(0, 0, 24, 79)
         DO KALEID WITH ALIAS() + '.dbf'
      ELSE
         exit
      ENDIF
   ELSE
      DO KALEID WITH ALIAS() + '.dbf'
      key = lastkey()
   ENDIF
ENDDO
IF ! firstloop
   SETCOLOR(oldcolor)
   RESTSCREEN(0, 0, 24, 79, oldscrn)
   IF ret_val    && file locked successfully - give user aural feedback
      DO CHARGE
   ENDIF
ENDIF
RETURN (ret_val)

* end function FileLock()
*--------------------------------------------------------------------*

* eof $fileloc.prg
