*:*********************************************************************
*:
*:        Program: $HELPACT()
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-90, Greg Lief
*:
*:      Additive search for DBEDIT()
*:
*:*********************************************************************
FUNCTION DBeditSrch
PARAMETER mtop, mleft, mbottom, mright, fields, heads, msgrow, midpoint
PRIVATE maxlength, srchstr, oldcolor, hilite, marker
marker = RECNO()
*** determine length of index key, which will in turn determine
*** the maximum length of the search string as well as where to
*** position it so that it is centered
maxlength = INDEXKEY(0)
IF TYPE(maxlength) = "C"
   srchstr = []
   maxlength = LEN(&maxlength)
   midpoint = midpoint - INT(maxlength / 2) + 2
   hilite = IF(ISCOLOR(), "+W/R", "I")
   oldcolor = SETCOLOR(hilite)
   @ msgrow, midpoint SAY '[ ' + SPACE(maxlength) + ' ]'
   SETCOLOR(oldcolor)
ENDIF
KEYBOARD CHR(255)   && bogus keypress to reset LASTKEY() below
DBEDIT(mtop, mleft, mbottom, mright, fields, 'helpact', '', heads)
IF LASTKEY() = 27
   GO marker
ENDIF
RETURN []

* end function DBEditSrch()
*--------------------------------------------------------------------*


*****************************************************
*
*  Function: HELPACT()
*
******************************************************
FUNCTION helpact
PARAM mode,indx
PRIVATE cur_field, key, ret_val, marker
cur_field = fields[indx]
key = LASTKEY()
ret_val = 1
DO CASE

   CASE mode < 4 .and. type('srchstr') <> "U"   && idle
      @ msgrow, midpoint + 2 + LEN(TRIM(srchstr)) SAY []

   CASE KEY = 27 .OR. KEY = 13   && Esc or Enter
      ret_val = 0

      * quick-search - backspace or alpha key
   CASE KEY = 8 .OR. (KEY > 31 .AND. KEY < 123) .AND. TYPE('srchstr')<>'U'
      *** backspace
      IF key = 8
         srchstr = SUBSTR(srchstr, 1, LEN(srchstr) - 1)
      ELSEIF LEN(srchstr) < maxlength
         srchstr = srchstr + UPPER(CHR(key))
      ENDIF
      marker = RECNO()
      SEEK srchstr
      IF ! FOUND()
         TONE(440,1)
         GO marker
         srchstr = SUBSTR(srchstr, 1, LEN(srchstr) - 1)
      ELSE
         ret_val = 2
      ENDIF
      oldcolor = SETCOLOR(hilite)
      @ msgrow, midpoint SAY '[ ' + srchstr + SPACE(maxlength-LEN(srchstr)) + ;
                             ' ]'
      SETCOLOR(oldcolor)
ENDCASE
RETURN ret_val

* end function QuickSrch()
*--------------------------------------------------------------------*

* eof $helpact.prg
