*:*********************************************************************
*:
*:        Program: ISSTATE()
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-90, Greg Lief
*:      Special Thanks to Mike Clerc for his input
*:
*:     Data validation function for State abbreviations
*:
*:     Calls: APICK()      (function in $APICK.PRG)
*:
*:*********************************************************************
FUNCTION IsState
PARAM tempstate
PRIVATE ret_val, states_[75], codes_[75]
ret_val = .T.
codes_[1]   = "AL"
codes_[2]   = "AK"
codes_[3]   = "AZ"
codes_[4]   = "AR"
codes_[5]   = "CA"
codes_[6]   = "CO"
codes_[7]   = "CT"
codes_[8]   = "DE"
codes_[9]   = "DC"
codes_[10]  = "FL"
codes_[11]  = "GA"
codes_[12]  = "HI"
codes_[13]  = "ID"
codes_[14]  = "IL"
codes_[15]  = "IN"
codes_[16]  = "IA"
codes_[17]  = "KS"
codes_[18]  = "KY"
codes_[19]  = "LA"
codes_[20]  = "ME"
codes_[21]  = "MD"
codes_[22]  = "MA"
codes_[23]  = "MI"
codes_[24]  = "MN"
codes_[25]  = "MS"
codes_[26]  = "MO"
codes_[27]  = "MT"
codes_[28]  = "NE"
codes_[29]  = "NV"
codes_[30]  = "NH"
codes_[31]  = "NJ"
codes_[32]  = "NM"
codes_[33]  = "NY"
codes_[34]  = "NC"
codes_[35]  = "ND"
codes_[36]  = "OH"
codes_[37]  = "OK"
codes_[38]  = "OR"
codes_[39]  = "PA"
codes_[40]  = "RI"
codes_[41]  = "SC"
codes_[42]  = "SD"
codes_[43]  = "TN"
codes_[44]  = "TX"
codes_[45]  = "UT"
codes_[46]  = "VT"
codes_[47]  = "VA"
codes_[48]  = "WA"
codes_[49]  = "WV"
codes_[50]  = "WI"
codes_[51]  = "WY"
codes_[54]  = "AS"
codes_[55]  = "FM"
codes_[56]  = "GU"
codes_[57]  = "MP"
codes_[58]  = "MH"
codes_[59]  = "PW"
codes_[60]  = "PR"
codes_[61]  = "VI"
codes_[64]  = "AB"
codes_[65]  = "BC"
codes_[66]  = "MB"
codes_[67]  = "NB"
codes_[68]  = "NF"
codes_[69]  = "NT"
codes_[70]  = "NS"
codes_[71]  = "ON"
codes_[72]  = "PE"
codes_[73]  = "PQ"
codes_[74]  = "SK"
codes_[75]  = "YT"
states_[1]  = "Alabama"
states_[2]  = "Alaska"
states_[3]  = "Arizona"
states_[4]  = "Arkansas"
states_[5]  = "California"
states_[6]  = "Colorado"
states_[7]  = "Connecticut"
states_[8]  = "Delaware"
states_[9]  = "District of Columbia"
states_[10] = "Florida"
states_[11] = "Georgia"
states_[12] = "Hawaii"
states_[13] = "Idaho"
states_[14] = "Illinois"
states_[15] = "Indiana"
states_[16] = "Iowa"
states_[17] = "Kansas"
states_[18] = "Kentucky"
states_[19] = "Louisiana"
states_[20] = "Maine"
states_[21] = "Maryland"
states_[22] = "Massachusetts"
states_[23] = "Michigan"
states_[24] = "Minnesota"
states_[25] = "Mississippi"
states_[26] = "Missouri"
states_[27] = "Montana"
states_[28] = "Nebraska"
states_[29] = "Nevada"
states_[30] = "New Hampshire"
states_[31] = "New Jersey"
states_[32] = "New Mexico"
states_[33] = "New York"
states_[34] = "North Carolina"
states_[35] = "North Dakota"
states_[36] = "Ohio"
states_[37] = "Oklahoma"
states_[38] = "Oregon"
states_[39] = "Pennsylvania"
states_[40] = "Rhode Island"
states_[41] = "South Carolina"
states_[42] = "South Dakota"
states_[43] = "Tennessee"
states_[44] = "Texas"
states_[45] = "Utah"
states_[46] = "Vermont"
states_[47] = "Virginia"
states_[48] = "Washington"
states_[49] = "West Virginia"
states_[50] = "Wisconsin"
states_[51] = "Wyoming"
states_[52] = "~"
states_[53] = "~U.S. Terrorities"
states_[54] = "American Samoa"
states_[55] = "Federated Micronesia"
states_[56] = "Guam"
states_[57] = "Mariana Islands"
states_[58] = "Marshall Islands"
states_[59] = "Palau Islands"
states_[60] = "Puerto Rico"
states_[61] = "Virgin Islands"
states_[62] = "~"
states_[63] = "~Canadian Provinces"
states_[64] = "Alberta"
states_[65] = "British Columbia"
states_[66] = "Manitoba"
states_[67] = "New Brunswick"
states_[68] = "Newfoundland"
states_[69] = "Northwest Territories"
states_[70] = "Nova Scotia"
states_[71] = "Ontario"
states_[72] = "Prince Edward Island"
states_[73] = "Quebec"
states_[74] = "Saskatchewan"
states_[75] = "Yukon"
IF ASCAN(codes_, tempstate) = 0
   ele = APICK(6, 29, 18, 51, states_, '', '', '', 75, .F., "+GR/B")
   IF ele = 0
      ret_val = .F.
   ELSE
      tempstate = codes_[ele]
   ENDIF
ENDIF
RETURN ret_val

* end function IsState()
*--------------------------------------------------------------------*

* eof $isstate.prg
