*:*********************************************************************
*:
*:        Program: MEMEDIT()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 02/06/89 - changed SET COLOR to SETCOLOR()
*:
*:  Procs & Fncts: MEMEDIT()
*:                 UFUNC()
*:
*:          Calls: CURS_TOP()    (Assembler function in CURSTOP.ASM)
*:               : CURS_BOT()    (Assembler function in CURSBOT.ASM)
*:               : NEWCURS()     (Assembler function in CURSNEW.ASM)
*:               : SHADOWBOX()   (function in $SHADOWB.PRG)
*:
*:     Generic memo editing function
*:
*:     Documented: 12/26/88 at 18:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION memedit
PARAM mfield, t, l, b, r, msg
*******************************************************
* PARAMETERS:                                         *
*              mfield = memo field to be edited       *
*              t = top row of box (default: 5)        *
*              l = left column of box (default: 10)   *
*              b = bottom row of box  (default: 19)   *
*              r = right column of box (default: 69)  *
*              msg = heading for box (optional)       *
*                                                     *
*******************************************************
PRIVATE old_color, oldscrn, ret_val, boxcol, buffer, mcurstop, mcursbot
boxcol = IF(ISCOLOR(), '+W/R', 'W/N')
mcurstop = Curs_Top()            && save current start line for cursor
mcursbot = Curs_Bot()            && save current end line for cursor
old_color=SETCOLOR(boxcol)
IF PCOUNT()=1          && user did not pass box coordinates - use defaults
   t = 5
   l = 10
   b = 19
   R = 69
ENDIF
oldscrn = Shadowbox(t, l, b, r, 1, IF(PCOUNT() = 6, msg, ''))
@ b, l + INT(r-l)/2 - 16 SAY 'Ctrl-W to save or Esc to abandon'
SETCOLOR('+W/N')
SCROLL(t+1, l+1, b-1, R-1, 0)
NewCurs(0, IF(ISCOLOR(), 7, 13))   && equivalent of SET CURSOR ON
memo = MEMOEDIT(&mfield., t+1, l+1, b-1, r-1, .T., 'escfunc', '', 3)
NewCurs(mcurstop,mcursbot)         && restore previous cursor
modified = (LASTKEY() <> 27)
IF modified
   IF RLOCK()
      REPLACE &mfield. WITH memo
      UNLOCK
   ELSE
      Err_msg('Unable to lock record, could not save edits at this time')
   ENDIF
   ret_val = .T.
ELSE
   INKEY(1)
   ret_val = .F.
   RESTSCREEN(0, 60, 0, 79, buffer)
ENDIF
ByeByeBox(oldscrn)
SETCOLOR(old_color)
RETURN(ret_val)

* end function MemEdit()
*--------------------------------------------------------------------*

FUNCTION EscFunc   && Alters "ABORT Y/N" msg if Esc is hit during Memoedit
PARAMETERS stat, line, col
IF LASTKEY() = 27
   TONE (500,1)
   TONE (500,1)
   buffer = SAVESCREEN(0, 60, 0, 79)
   @ 0,60 SAY 'MEMO NOT UPDATED    '
ENDIF
RETURN (0)

* end function EscFunc()
*--------------------------------------------------------------------*

* eof $memedit.prg
