*:*********************************************************************
*:
*:        Program: MENUH()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 01/24/90 - removed OLD_COLOR as a parameter
*:                            (totally unnecessary - whoops!)
*:
*:  Creates horizontal bounce-bar menu
*:
*:     Documented: 01/01/89 at 12:35                SNAP! version 3.10
*:*********************************************************************
FUNCTION Menuh
*
*   PARAMETERS:
*
*   REQUIRED: ROW = row to display menu selections
*             COL = starting column
*             SPC = spacing between menu selections
*             PROMPT_STR = prompts (each must end with '$')
*
*   OPTIONAL: MSG_STR = messages (each must end with '$') (optional)
*             MCOLOR =  menu color (optional - default is standard/inverse)
*
*****************
PARAM row, col, spc, prompt_str, msg_str, mcolor
PRIVATE prom, msg, choice, ptr1, ptr2, old_color
mcolor = IF(PCOUNT() < 6 .OR. ! ISCOLOR(), 'w/n,i', mcolor)
msg_str = IF(PCOUNT() < 5, '', msg_str)
STORE 1 TO ptr1, ptr2, choice
old_color = SETCOLOR(mcolor)
IF AT('$', prompt_str) = 0
   Err_msg('Error in call to function MENUH()')
ELSE
   prompt_str = TRIM(prompt_str)
   prompt_str = prompt_str + ;
                IF(SUBSTR(prompt_str, LEN(prompt_str),1) = '$', '', '$')
   DO WHILE ptr1 < LEN(prompt_str)
      prom = SUBSTR(prompt_str, 1, AT('$', prompt_str) - 1)
      msg = SUBSTR(msg_str, 1, AT('$', msg_str) - 1)
      @ row, col PROMPT prom MESSAGE msg
      prompt_str = SUBSTR(prompt_str, AT('$',prompt_str) + 1, ;
                   LEN(prompt_str) - AT('$', prompt_str))
      msg_str = SUBSTR(msg_str, AT('$', msg_str) + 1, ;
                LEN(msg_str) - AT('$', msg_str))
      col = col + LEN(PROM) + spc
   ENDDO
   MENU TO choice
ENDIF
SETCOLOR(old_color)
RETURN(choice)

* end function MenuH()
*--------------------------------------------------------------------*

* eof $menuh.prg
