*:*********************************************************************
*:
*:        Program: CHECKMOVE()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 09/03/89
*:
*:      Called by: POPCALC
*:                 POPSTOP
*:
*:     Handles screen movement of desktop utility windows
*:     Returns Logical Value: .T. if window was moved, .F. if not
*:
*:     NOT FOR USE AS A STAND-ALONE FUNCTION!!!
*:
*:*********************************************************************
FUNCTION CheckMove
PARAMETER topoffset, leftoffset
PRIVATE buffer, ret_val
ret_val = .F.
IF (keypress = 5 .AND. mtop > 0) .OR. ;                    && Up Arrow
   (keypress = 24 .AND. mtop < 24 - topoffset) .OR. ;      && Down Arrow
   (keypress = 19 .AND. mleft > 0) .OR. ;                  && Left Arrow
   (keypress = 4 .AND. mleft < 79 - leftoffset) .OR. ;     && Right Arrow
   keypress = 1 .OR. keypress = 6 .OR. ;                   && Home, End
   keypress = 18 .OR. keypress = 3 .OR. ;                  && PgUp, PgDn
   keypress = 26 .OR. keypress = 2                         && ^Left, ^Right

   ** save screen image at current location
   buffer = SAVESCREEN(mtop, mleft, mtop+topoffset-1, mleft+leftoffset-2)
   RESTSCREEN(mtop, mleft, mtop + topoffset, mleft + leftoffset, oldscrn)

   ** determine new screen coordinates for calculator box
   ** first check for 'big moves' (Home, End, PgUp, PgDn, ^Left, ^Right)
   IF keypress = 1 .OR. keypress = 6 .OR. keypress = 18 .OR. ;
            keypress = 3 .OR. keypress = 26 .OR. keypress = 2
      mtop  = IF(keypress = 1 .OR. keypress = 18, 0, ;
              IF(keypress = 3 .OR. keypress = 6, 24 - topoffset, mtop))
      mleft = IF(keypress = 1 .OR. keypress = 26, 0, ;
              IF(keypress = 6 .OR. keypress = 2, 79 - leftoffset, mleft))
   ELSE
      mtop = mtop - IF(keypress = 24, -1, IF(keypress = 5, 1, 0))
      mleft = mleft - IF(keypress = 4, -1, IF(keypress = 19, 1, 0))
   ENDIF
   oldscrn = SAVESCREEN(mtop, mleft, mtop + topoffset, mleft + leftoffset)
   gfattr(mtop+1, mleft+leftoffset-1, mtop+topoffset-1, mleft+leftoffset, 8)
   gfattr(mtop+topoffset-1, mleft+2, mtop+topoffset, mleft+leftoffset, 8)
   RESTSCREEN(mtop, mleft, mtop+topoffset-1, mleft+leftoffset-2, buffer)
   ret_val = .T.
ENDIF
RETURN (ret_val)

* end function CheckMove()
*--------------------------------------------------------------------*

* eof $moving.prg
