*:*********************************************************************
*:
*:        Program: NET_USE()
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-90, Greg Lief
*:
*:  Opens files for exclusive and shared use in multi-user systems
*:
*:*********************************************************************
FUNCTION Net_use
PARAM mfile, excl_use, ndx1, ndx2, ndx3, ndx4, ndx5, ndx6, ndx7, ndx8
PRIVATE firstloop, ret_val, box_no, color_str, oldcolor, buffer, ;
   oldscrn, malias, key
*------------------------------------------------------
* Variables BOX_NO, BUFFER, OLDCOLOR, COLOR_STR are initialized in
* KALEID.prg, but must be declared private in this routine or else
* KALEID will bomb the second time it is called below.
*------------------------------------------------------
* make sure parameter EXCL_USE is logical type
IF TYPE('excl_use') != 'L'
   Err_msg('Must pass logical value for file lock.... NET_USE()')
   RETURN(.F.)
ENDIF
SELECT 0
ret_val = .F.
firstloop = .T.
*** did they pass an alias as part of the filename
ptr = AT("ALIAS", UPPER(mfile))
IF ptr > 0
   malias = TRIM(SUBSTR(mfile, ptr + 6))
   mfile = SUBSTR(mfile, 1, ptr - 1)
ELSE
   malias = ''
ENDIF
key = 0
DO WHILE key != 27
   IF excl_use
      IF ! EMPTY(malias)
         USE (mfile) EXCLUSIVE ALIAS &malias
      ELSE
         USE (mfile) EXCLUSIVE
      ENDIF
   ELSE
      IF ! EMPTY(malias)
         USE (mfile) ALIAS &malias
      ELSE
         USE (mfile)
      ENDIF
   ENDIF
   IF ! NETERR()     && file opened successfully - now open indexes
      ret_val = .T.
      DO CASE
         CASE PCOUNT() = 3
            SET INDEX TO (ndx1)
         CASE PCOUNT() = 4
            SET INDEX TO (ndx1), (ndx2)
         CASE PCOUNT() = 5
            SET INDEX TO (ndx1), (ndx2), (ndx3)
         CASE PCOUNT() = 6
            SET INDEX TO (ndx1), (ndx2), (ndx3), (ndx4)
         CASE PCOUNT() = 7
            SET INDEX TO (ndx1), (ndx2), (ndx3), (ndx4), (ndx5)
         CASE PCOUNT() = 8
            SET INDEX TO (ndx1), (ndx2), (ndx3), (ndx4), (ndx5), (ndx6)
         CASE PCOUNT() = 9
            SET INDEX TO (ndx1), (ndx2), (ndx3), (ndx4), (ndx5), (ndx6), (ndx7)
         CASE PCOUNT() = 10
            SET INDEX TO (ndx1), (ndx2), (ndx3), (ndx4), (ndx5), (ndx6), (ndx7), (ndx8)
      ENDCASE
      EXIT
   ELSE
      IF firstloop
         IF Yes_no('File ' + mfile + ' cannot be opened at this time', ;
               'Would you like to wait')
            oldscrn = SAVESCREEN(0, 0, 24, 79)
            DO KALEID WITH UPPER(mfile)
         ELSE
            EXIT
         ENDIF
      ELSE
         DO KALEID WITH UPPER(mfile)
      ENDIF
   ENDIF
   key = LASTKEY()
ENDDO
IF ! firstloop
   SETCOLOR(oldcolor)
   RESTSCREEN(0, 0, 24, 79, oldscrn)
   IF ret_val   &&& file opened successfully - give user aural feedback
      DO CHARGE
   ENDIF
ENDIF
RETURN (ret_val)

* end function Net_Use()
*--------------------------------------------------------------------*

* eof $netuse.prg

