*:*********************************************************************
*:
*:        Program: PRINTOK()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 02/06/89   - changed SET COLOR to SETCOLOR()
*:                 03/02/89   - added SEZ parameter so that this can
*:                              be used with ? and ?? (SET PRINT ON)
*:                              this suggestion courtesy of Robert Scher
*:
*:  Ensures that printer is on-line before printing
*:
*:     Documented: 12/26/88 at 18:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION printok
PARAM sez
PRIVATE ret_val, oldcolor, oldscrn
sez = (PCOUNT() = 0)      && if no parameter passed, assume use of @...SAYs
ret_val = .T.
IF ! ISPRINTER()
   oldcolor = SETCOLOR(IF(ISCOLOR(), '+W/R', '+W/N'))
   oldscrn = Shadowbox(09, 11, 14, 67, 3, 'Printer Error')
   @ 10, 13 SAY 'Common problems include: out of paper, paper jammed,'
   @ 11, 13 SAY 'off-line, printer unplugged, cable loose or unplugged'
   @ 12, 13 SAY 'Please check your printer and press any key to resume'
   @ 13, 17 SAY '(Press Esc key to abort this print operation)'
   SET CONSOLE OFF
   DO WHILE ! ISPRINTER() .AND. LASTKEY() != 27
      TONE(660,1)
      TONE(660,1)
      WAIT ''
   ENDDO
   SET CONSOLE ON
   ByeByeBox(oldscrn)
   SETCOLOR(oldcolor)
   IF LASTKEY() = 27
      ret_val = .F.
   ENDIF
ENDIF
IF ret_val
   IF sez
      SET DEVICE TO PRINT
   ELSE
      SET PRINT ON
   ENDIF
ENDIF
RETURN(ret_val)

* end function PrintOK()
*--------------------------------------------------------------------*

* eof $printok.prg
