********************************************************************
*
*  FUNCTION: PsychoPath()
*  AUTHOR:   Greg Lief (with a name like that, was there any doubt?)
*  DATE:     Tuesday, August 21, 1990
*  PURPOSE:  Find a file in the DOS path
*  SYNTAX:   PsychoPath(<file name to find>)
*  RETURNS:  Character string: either the path in which the file
*            exists, or a null string if the file was not found
*            in the DOS path
*  DIALECT:  Summer '87
*
********************************************************************
FUNCTION PsychoPath
PARAMETER mfile
PRIVATE dos_path, ret_val, ptr
ret_val = []
dos_path = GETE("PATH") + ";"
ptr = AT(";", dos_path)
DO WHILE ptr > 0
   ret_val = SUBSTR(dos_path, 1, ptr - 1)
   ret_val = ret_val + IF(RIGHT(ret_val, 1) != '\', '\', '')
   IF FILE(ret_val + mfile)
      EXIT
   ELSE
      dos_path = SUBSTR(dos_path, ptr + 1)
      ptr = AT(";", dos_path)
      ret_val = []
   ENDIF
ENDDO
RETURN ret_val

* end function PsychoPath()
*--------------------------------------------------------------------*

* eof $psycho.prg
