*:*********************************************************************
*:
*:        Program: Rainbow()
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988-90, Greg Lief
*:      Clipper Summer '87 version
*:
*:      Display character string in continuously falling rainbow format
*:
*:          Calls: CURS_TOP()    (Assembler function in CURSTOP.ASM)
*:               : CURS_BOT()    (Assembler function in CURSBOT.ASM)
*:               : NEWCURS()     (Assembler function in CURSNEW.ASM)
*:
*:*********************************************************************
function rainbow
parameter cstring
private key, nrow, whichcolor, colors_[7], mcurstop, mcursbot, oldcolor
oldcolor = setcolor()
mcurstop = curs_top()
mcursbot = curs_bot()
newcurs(32, 0)       && turn off cursor
whichcolor = 1
nrow = 3
colors_[1] = 'W'
colors_[2] = 'BR'
colors_[3] = 'R'
colors_[4] = 'GR'
colors_[5] = 'BG'
colors_[6] = 'B'
colors_[7] = 'G'
do while .t.
   do case
      case ! showstring(whichcolor, cstring, nrow, nrow + 2)
         exit
      case nrow < 18
         nrow = nrow + 3
      otherwise
         nrow = 3
   endcase
   whichcolor = whichcolor + 1
enddo
setcolor(oldcolor)
newcurs(mcurstop, mcursbot)
return 0

* end function Rainbow()
*--------------------------------------------------------------------*


*!*********************************************************************
*!
*!      Function: ShowString()
*!
*!      Called by: RainBow()
*!
*!*********************************************************************
function showstring
parameter whichcolor, cstring, nstart, nstop
private nrow, ret_val
ret_val = .t.    && set False if they bust out of the loop
setcolor('+' + colors_[whichcolor % 7 + 1] + '/N')
for nrow = nstart to nstop
   Center(nrow, cstring)
   if inkey(.03) != 0
      ret_val = .f.
      exit
   endif
next
return ret_val

* end function ShowString()
*--------------------------------------------------------------------*

* eof $rainbow.prg
