************************************************************
*
*  Function: GFReadLine()
*  Author:   Greg Lief
*  Copyright (c) 1990 Grumpfish, Inc. - All Rights Reserved
*
*  Purpose:  Read in the next string from the text file
*            (i.e., up to the next CR/LF combo)
*
*  Syntax:   GFReadLine(@<string>, <handle>)
*
*  Parameters:  <string> is the character variable which will
*               will hold the string.  NOTE: this must be
*               passed by reference (preceded by a "@")!!
*
*               <handle> is the file handle to read the string
*               from.  This would have been returned from either
*               FOPEN() or FCREATE().
*
*  Returns:  Logical value: .T. if successful, .F. if EOF()
*
************************************************************
FUNCTION gfreadline
PARAMETER mstring, handle
PRIVATE ret_val, buffer, ptr, bytes, bufsize, tempstring, crlf
crlf = CHR(13) + CHR(10)
mstring = []
bufsize = 255
buffer = SPACE(bufsize)
ret_val = .T.
DO WHILE .T.
   bytes = FREAD(handle, @buffer, bufsize)
   tempstring = LEFT(buffer, bytes)
   ptr = AT(crlf, tempstring)
   IF ptr > 0
      mstring = mstring + substr(tempstring, 1, ptr-1)
      fseek(handle, -(bytes - (ptr + 1)), 1)
      EXIT
   ELSE
      mstring = mstring + tempstring
      IF bytes < bufsize
         ret_val = .F.
         EXIT
      ENDIF
   ENDIF
ENDDO
RETURN ret_val

* end function GFReadLine()
*--------------------------------------------------------------------*

* eof $readlin.prg
