*:*********************************************************************
*:
*:        Program: REC_LOCK()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 10/29/88     19:46
*:
*:      Attempts to lock record in multi-user environment
*:
*:     Documented: 12/26/88 at 18:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION Rec_Lock
PRIVATE firstloop, box_no, buffer, oldcolor, color_str, ret_val, ;
        oldscrn, key
*------------------------------------------------------
* Variables Used:
*   FIRSTLOOP = flag so that user is asked to wait only on
*               first iteration - set false after that
*   RET_VAL   = value to be returned
*   OLDSCRN   = used to save previous screen if user decides to wait
*
* Variables BOX_NO, BUFFER, OLDCOLOR, COLOR_STR are initialized in
* KALEID.prg, but must be declared private in this routine or else
* KALEID will bomb the second time it is called below.
*
*------------------------------------------------------
IF LEN(ALIAS())=0   && no database in use
   RETURN(.F.)
ENDIF   
firstloop = .T.
ret_val = .F.
key = 0
DO WHILE key != 27 .AND. ! ret_val
   IF RLOCK()
      ret_val = .T.
   elseif firstloop
      IF Yes_no('Cannot lock this record at this time', ;
            'Would you like to wait')
         oldscrn = savescreen(0, 0, 24, 79)
         DO kaleid WITH 'record'
      ELSE
         exit
      ENDIF
   ELSE
      DO kaleid WITH 'record'
      key = lastkey()
   ENDIF
ENDDO
IF ! firstloop
   SETCOLOR(oldcolor)
   restscreen(0, 0, 24, 79, oldscrn)
   IF ret_val  && record locked successfully - give user aural feedback
      DO CHARGE
   ENDIF
ENDIF
RETURN (ret_val)

* end function Rec_Lock()
*--------------------------------------------------------------------*

* eof $reclock.prg
