*:*********************************************************************
*:
*:        Program: TTY()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 01/21/89      19:43
*:
*:  Displays message on screen "teletype" style until keypress
*:
*:     Documented: 01/21/89 at 20:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION Tty
PARAM xrow, msg, delay, stopcol
*---------------------------------------------------------------------
*  XROW  = row at which to display message
*  MSG   = message to display
*  DELAY = delay factor (default or if zero passed: use sound)
*  STOPCOL = column at which to stop display (optional - default none)
*---------------------------------------------------------------------
PRIVATE oldrow, oldcol, xcol, yy, mcurstop, mcursbot, winbuff
oldrow = ROW()                && save current screen coordinates
oldcol = COL()
mcurstop = curs_top()         && get the current cursor starting scan line
mcursbot = curs_bot()         && get the current cursor ending scan line
* set sound and stop column if parameters were not passed
delay = IF(PCOUNT() < 3, 0, delay)
stopcol = IF(PCOUNT() < 4, -1, stopcol)
winbuff = SAVESCREEN(xrow,0,xrow,79)
newcurs(32,0)                 && functional equivalent of SET CURSOR off
xcol = 0
DO WHILE INKEY() = 0 .AND. stopcol != xcol
   @ xrow, xcol SAY CHR(32) + IF(xcol < 79, SUBSTR(msg, 1, 79 - xcol), '')
   IF 79 - xcol < LEN(msg)
      @ xrow, 0 SAY SUBSTR(msg, 80 - xcol, LEN(msg) - 79 + xcol)
   ENDIF
   IF delay = 0
      TONE(25,1)
   ELSE
      FOR yy = 1 TO delay
      NEXT
   ENDIF
   xcol = IF( xcol = 79, 0, xcol + 1)
ENDDO
** reset previous environment
@ oldrow, oldcol SAY ''
newcurs(mcurstop,mcursbot)
IF PCOUNT() < 4         && do not restore screen if stop column was passed
   RESTSCREEN(xrow,0,xrow,79,winbuff)
ENDIF
RETURN []

* end function TTY()
*--------------------------------------------------------------------*

* eof $tty.prg
