*:*********************************************************************
*:
*:        Program: TTY2().PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief, with help from Dennis Levin
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 03/12/89
*:
*!       Function: TTY2()
*!
*!          Calls: CURS_TOP()     (Assembler routine in Grump.LIB)
*!               : CURS_BOT()     (Assembler routine in Grump.LIB)
*!               : NEWCURS()      (Assembler routine in Grump.LIB)
*!
*:      Documented 03/08/89 at 10:00                SNAP!  version 3.12a
*!*********************************************************************
FUNCTION tty2
PARAM mrow, msg, delay, newcolor
PRIVATE oldrow, oldcol, mlen, leftcol, xcol, mstart, mstring, yy, ;
        mcurstop, mcursbot, buff, oldcolor

** truncate the message if longer than 70 characters
** use default message if a null string was passed
msg = IF(LEN(TRIM(msg)) = 0, 'Press any key to continue', SUBSTR(msg, 1, 70))

** set delay factor to 0 if it was not passed and make sure it is a numeric!
delay = IF(PCOUNT() < 3, 0, IF(TYPE('delay')='N', delay, 0))
 
** use current color if color parameter was not passed
newcolor = IF(PCOUNT() < 4, SETCOLOR(), newcolor)
oldcolor = SETCOLOR(newcolor)

oldrow = ROW()                     && save current screen coordinates
oldcol = COL()
mcurstop = curs_top()              && get current cursor starting scan line
mcursbot = curs_bot()              && get current cursor ending scan line
newcurs(32,0)                      && functional equivalent of SET CURSOR off
buff = SAVESCREEN(mrow,0,mrow,79)  && save affected portion of screen
mlen = LEN(msg)+10                 && determine how many dots to use
leftcol = INT((80-mlen)/2)
@ mrow, leftcol SAY REPLICATE(CHR(46),mlen)
xcol = leftcol + mlen - 6          && start five columns from the right
mstart = 1                         && substring ptr for when we hit the left
DO WHILE INKEY() = 0
   mstring = SUBSTR(msg, mstart, mlen + leftcol - xcol - 5) + ;
      IF(mstart > 1, REPLICATE(CHR(46), mstart-1), '')
   @ mrow, xcol SAY mstring
   IF delay = 0            && use sound
      TONE(25,1)
   ELSE
      FOR yy = 1 TO delay
      NEXT
   ENDIF
   IF xcol = leftcol + 5                      && we're at the left side
      mstart = mstart + 1
      IF mstart > LEN(msg)                    && time to go back to the right
         @ mrow, xcol SAY CHR(46)             && clear remainder of message
         xcol = leftcol + mlen - 5            && reset column pointer
         mstart = 1                           && reset substring pointer
      ENDIF
   ELSE
      xcol = xcol - 1
   ENDIF
ENDDO
** reset previous environment
RESTSCREEN(mrow,0,mrow,79,buff)
SETCOLOR(oldcolor)
@ oldrow, oldcol SAY ''
newcurs(mcurstop,mcursbot)
RETURN []

* end function TTY2()
*--------------------------------------------------------------------*

* eof $tty2.prg
