*:*********************************************************************
*:
*:        Program: YES_NO()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 02/06/89 - changed SET COLOR to SETCOLOR()
*:
*:     Display a Yes/No question and wait for user to respond
*:
*:     Documented: 03/12/89 at 12:55                 SNAP! version 3.10
*:*********************************************************************
FUNCTION Yes_no
PARAM msg, msg2, box_clr, text_clr
PRIVATE wid, oldcolor, oldscrn, oneline, mtoprow
oneline = .T.

** determine how many lines will be displayed, and top row of box
IF PCOUNT() > 1
   oneline = (LEN(msg2) = 0)  && ensure that msg2 is not a null string
ENDIF
mtoprow = IF(oneline, 20, 19)

IF oneline
   msg=msg + '? Y/N '
   wid=INT(MAX(74 - LEN(msg), 0)) / 2
ELSE
   msg2=msg2 + '? Y/N '
   wid=INT(74 - MAX(LEN(msg), LEN(msg2))) / 2
ENDIF

** establish box and text colors if not passed as parameters
IF PCOUNT() > 2
   box_clr = IF(LEN(box_clr) > 0, box_clr, IF(ISCOLOR(), 'W/RB', 'W/N'))
ELSE
   box_clr = IF(ISCOLOR(), 'W/RB', 'W/N')
ENDIF
text_clr = IF(PCOUNT() = 4, text_clr, '+' + box_clr)

oldcolor = SETCOLOR(box_clr)
oldscrn = Shadowbox(mtoprow, wid, 22, 79-wid, 3)
SETCOLOR(text_clr)
Center(IF(oneline, 21, 20),msg)
IF ! oneline
   Center(21,msg2)
ENDIF
DO WHILE ! CHR(INKEY()) $ 'YyNn'
ENDDO
ByeByeBox(oldscrn)
SETCOLOR(oldcolor)
RETURN (CHR(LASTKEY()) $ 'Yy')

* end function Yes_No()
*--------------------------------------------------------------------*

* eof $yesno.prg
